// GLWVideo.cpp: implementation of the GLWVideo class.
// by Oligoatria
//////////////////////////////////////////////////////////////////////

#include <windows.h>		// File d'Intestazione per Windows
#include <math.h>			// File d'Intestazione per la libreria Matematica
#include <stdio.h>			// File d'Intestazione per Standard Input/Output
#include <gl\gl.h>			// File d'Intestazione per la libreria OpenGL32 
#include <gl\glu.h>			// File d'Intestazione per la libreria GLu32 
#include <gl\glaux.h>		// File d'Intestazione per la libreria Glaux 
#include "JPEG.h"           // Funzioni per il caricamento di texture JPEG

#include "GLWVideo.h"

////// Defines
#define BITMAP_ID 0x4D42		// the universal bitmap ID

#define MAX_LENGHT_NOMEFILE 32


/* Variabili chiave dell'applicazione */
	extern HDC			hDC;		// Device Context GDI privato
	extern HGLRC		hRC;		// Rendering Context permanente
	extern HWND			hWnd;		// Handle alla Finestra 
	extern HINSTANCE	hInstance;	// Istanza dell'Applicazione


	extern bool	keys[256];			// Array usato per la routine della tastiera
	extern bool	active;		// Flag di Finestra Attiva, settato a TRUE di default

/* Movimento del soggetto */
	extern float	heading;
	extern float	xpos;
	extern float	zpos;
	extern float	ypos;
	extern int		vel_gra;

	extern GLfloat	yrot;				// Rotazione Y 
	extern GLfloat  walkbias;
	extern GLfloat  walkbiasangle;
	extern GLfloat  lookupdown;
	extern GLfloat	z;				    // Profondit nello Schermo
	int lol;

	extern unsigned short int DirezioneComandi;

/* Costanti matematiche */
	const float piover180 = 0.0174532925f;

/* variabili di gioco */
	extern int vittoria;  // 0 niente, -1 sconfitta, 1 vittoria (l'uscita  considerata come sconfitta */
	
/* variabili di stato */
	extern int STATE;

/* Definizioni di strutture */
	struct TEXTURE
	{
		/*GLuint*/UINT texture;			// Spazio per Texture
		TEXTURE *next;
		char nome_file[MAX_LENGHT_NOMEFILE];     // nome_file, serve per non inserire texture doppione
	};

	TEXTURE	*texture_testa, *texture_pos;			// Lista di Texture // inserir gli elementi in coda, per facilitarne la ricerca

	typedef struct tagVERTEX
	{
		float x, y, z;
		float u, v;
		bool normale;             // se devo impostare la normale
		float nx, ny, nz;         // orientamento della normale
	} VERTEX;

	typedef struct tagTRIANGLE
	{
		VERTEX vertex[3];
		int n_texture;           // indice della texture interessata
	} TRIANGLE;

	typedef struct tagSECTOR
	{
		int numtriangles;
		TRIANGLE* triangle;
	} SECTOR;

	/* per il caricamento diretto da file nff */
		struct POLIGONO
		{
			int numVertex;
			int *IndexVertex; // array degli indici dei vertici del poligono
			int n_texture;           // indice della texture interessata
		};

		struct Oggetto
		{
			/* vertici */
				int numVertex;
				VERTEX *Vertex; // array di lunghezza numVertex -> da inizializzare in SetupWorld_nff
								  // non uso una lista perch  necessario avere un facile indirizzamento ad ogni elemento
			/* poligoni */
				int numPoligoni;
				POLIGONO *Poligoni;  // array di poligoni			

			Oggetto *next;
		};

		struct SECTOR_OBJ
		{			
			Oggetto *oggetti;
			bool blend;
			            
			/* Fattori di posizione */ // se si tratta di un modello da inserire nello spazio sono utili
				float x, y, z, xrot, yrot, zrot, esplosione;
				BOOL selezionabile, visible;
				int selezionato;               // 0 - No,  1 - Temporaneamente,  2 - Pezzo da muovere
				int cursore;   // 0 - No, 1 - mossa non permessa, 2 - mossa permessa
				int flip;
		};

		struct SECTOR_OBJ_LIST
		{
			int ID_Obj;
			SECTOR_OBJ ObjSect;
			SECTOR_OBJ_LIST *next;
		};

/* fps */
	BOOL fpsActive; // se visualizzo a video lo stato attuale della variabile fps
	extern int fps;        // devono essere 60
	extern int ral;

/* oggetti grafici */

	SECTOR sector1;			           // Il nostro modello world andr qui:
	SECTOR_OBJ ObjSect1;               // Qui salvo il modello caricato direttamente dall'nff world
	SECTOR_OBJ ObjSectScacchi[32];     // Qui salvo i modelli degli scacchi
	SECTOR_OBJ ObjSectCur;             // cursore
	SECTOR_OBJ_LIST *ObjSectList;      // Lista di oggetti aggiuntivi // punta alla testa della lista

/* scacchiera */
	short int scac[10][10];  // contiene elementi diversi della scac[10][10] in Scacchi.h :
	                        // quella guarda il tipo di pezzo
	                        // questa struttura, invece, contiene l'indice del pezzo specifico ( in SECTOR_OBJ ObjSectScacchi[32] )

/* posizione del cursore */
	extern int tmpMossa, mossa;    // calcolo della mossa - in base al suo valore so se  stata decisa una muova operazione
    extern float CurX, CurZ; // cursore di selezione del pezzo
	extern float ICurX, ICurZ;  // posizione iniziale del cursore
    extern float QUAD_W;
	extern int Mat_x, Mat_y;    // indici della griglia-scacchiera
	extern int da_x, da_y;      // muovo il pezzo in posizione da_x, da_y
    int rgb_var;             // variabile per il colore del pezzo selezionato  	


//material properties
GLfloat specular[] = {0.5f, 0.5f, 0.5f, 0.5f};
GLfloat shininess[] = {0.5f};


extern LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Prototipo di funzione per WndProc


//////////////////////////////////////////////////////////////////////
// class GLWVideo
//////////////////////////////////////////////////////////////////////

GLWVideo::GLWVideo()
{
	
};

GLWVideo::~GLWVideo()
{

};


GLWVideo::GLWVideo(float ral, int x, int y, int bits)
{		
	fullscreen=TRUE;
	
	Screen_X=x;
	Screen_Y=y;
	Screen_BITS=bits;

	fpsActive=false;
	fps=0;	

	/* avversario */
		mostraAvversario=false;
		menuBMPData=NULL;
		imgAvvNorm=NULL;
		imgAvvAttacca=NULL;
		imgAvvSubisce=NULL;
		imgStage=NULL;		
	
	InitWorldVar();
};

void GLWVideo::InitWorldVar()
{
	riconoscimenti=false;
	sto_mangiando=false;
	lol=0;
	Rallentamento=ral;

	walkbias = 0;
	walkbiasangle = 0;	
	
	avanti=0;
	giu=0;

	/* Posizione della visuale - da men */
		lookupdown = 0.0f;	

		ypos=4.2f/RIMPICCIOLISCO_IL_MONDO_DI;
		xpos=-5.0f/RIMPICCIOLISCO_IL_MONDO_DI;
		zpos=-4.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
		yrot = 180.0f;
		
	vittoria=0;

	ObjSect1.oggetti=NULL;
	mossa=0;                    // fondamentale
	tmpMossa=0;

	ObjSectList=NULL;   // lista vuota		
	DirezioneComandi=1;  // punto di vista dei bianchi // l'inizializzazione non  certo nel posto pi elegante, ma cos non devo ripetermi

	/* testo e men */
		testoActive=false;
		scriviChat=false;
		menuCom=NULL;
		selCom=NULL;
		chatMioTesto[0]='\0';
		chatSuoTesto[0]='\0';
		chatMioTestoLength=0;
};

void GLWVideo::readstr(FILE *f,char *string)
{
	do
	{
		fgets(string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));   // vado a capo finch ho commenti o righe vuote
	return;
};

AUX_RGBImageRec *GLWVideo::LoadBMP(char *Filename)				// Carica un'immagine Bitmap 
{
	FILE *File=NULL;									// Handle a File 

	if (!Filename)										// Si assicura che il nome di file sia stato indicato
    {
		return NULL;									// Se no, restituisce NULL
    }

	File=fopen(Filename,"r");							// Test per vedere se il file esiste
        
	if (File)											// Il file esiste?
	{
		fclose(File);									// Chiude l'Handle
		return auxDIBImageLoad(Filename);				// Carica la Bitmap e restituisce un puntatore
	}

	return NULL;										// Se il caricamento fallisce restituisce NULL
};

// LoadBitmapFile
// desc: Returns a pointer to the bitmap image of the bitmap specified
//       by filename. Also returns the bitmap header information.
//		 No support for 8-bit bitmaps.
/* funzione ricavata da: */
/*******************************************************************
*	Program: Chapter 7 Bitmap Example 2
*	Author: Kevin Hawkins
*	Description: Loads and displays a bitmap in the window.
********************************************************************/
// ATTENZIONE: le immagini devono avere valori dimensionali pari
unsigned char *GLWVideo::LoadBitmapFile(char *filename, BITMAPINFOHEADER *bitmapInfoHeader)
{
	FILE *filePtr;								// the file pointer
	BITMAPFILEHEADER	bitmapFileHeader;		// bitmap file header
	unsigned char		*bitmapImage;			// bitmap image data
	int					imageIdx = 0;			// image index counter
	unsigned char		tempRGB;				// swap variable

	// open filename in "read binary" mode
	filePtr = fopen(filename, "rb");
	if (filePtr == NULL)
		return NULL;

	// read the bitmap file header
	fread(&bitmapFileHeader, sizeof(BITMAPFILEHEADER), 1, filePtr);
	
	// verify that this is a bitmap by checking for the universal bitmap id
	if (bitmapFileHeader.bfType != BITMAP_ID)
	{
		fclose(filePtr);
		return NULL;
	}

	// read the bitmap information header
	fread(bitmapInfoHeader, sizeof(BITMAPINFOHEADER), 1, filePtr);

	// move file pointer to beginning of bitmap data
	fseek(filePtr, bitmapFileHeader.bfOffBits, SEEK_SET);

	// allocate enough memory for the bitmap image data
	bitmapImage = (unsigned char*)malloc(bitmapInfoHeader->biSizeImage);

	// verify memory allocation
	if (!bitmapImage)
	{
		free(bitmapImage);
		fclose(filePtr);
		return NULL;
	}

	// read in the bitmap image data
	fread(bitmapImage, 1, bitmapInfoHeader->biSizeImage, filePtr);

	// make sure bitmap image data was read
	if (bitmapImage == NULL)
	{
		fclose(filePtr);
		return NULL;
	}

	// swap the R and B values to get RGB since the bitmap color format is in BGR
	for (imageIdx = 0; imageIdx < bitmapInfoHeader->biSizeImage; imageIdx+=3)
	{
		tempRGB = bitmapImage[imageIdx];
		bitmapImage[imageIdx] = bitmapImage[imageIdx + 2];
		bitmapImage[imageIdx + 2] = tempRGB;
	}

	// close the file and return the bitmap image data
	fclose(filePtr);
	return bitmapImage;
}

int GLWVideo::LoadGLTextures()   // inizializza le variabili relative alle textures
{	
	texture_testa=NULL;
	texture_pos=NULL;

	return TRUE;
};

int GLWVideo::AddTexture(char *nome_file)
{
	int Status=FALSE;									// Indicatore dello stato 
	TEXTURE *tNew;

	AUX_RGBImageRec *TextureImage[1];					// Crea spazio per la texture

	memset(TextureImage,0,sizeof(void *)*1);           	// Setta il puntatore a NULL

	char ff[255];
	strcpy(ff, "data/textures/");  // directory di default
	strcpy(&ff[14], nome_file);
	
	/* gestione lista */
		tNew=new TEXTURE;
		tNew->next=NULL;
		if (texture_testa==NULL)       // lista non molto "raffinata", ma efficace
			texture_testa=tNew;
		else
			texture_pos->next=tNew;	
		texture_pos=tNew;

	// Carica la JPEG o Bitmap, testa per errori, se la non viene trovato il file chiude l'applicazione
	if (TextureImage[0]=LoadBMP(ff))  
	{
		Status=TRUE;							// Setta la variabile Status a TRUE
		
		glGenTextures(1, &tNew->texture);          // Crea la texture

		// Crea una Texture MipMapped 
		glBindTexture(GL_TEXTURE_2D, tNew->texture);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
	}
	else if (JPEG_Texture(&tNew->texture, ff)==1)
	{		
		Status=TRUE;		
	}

    if (TextureImage[0])						// Se la texture esiste
	{
		if (TextureImage[0]->data)              // Se l'immagine texture esiste
        {
			free(TextureImage[0]->data);        // Libera la memoria per l'immagine Texture 
        }
		
		free(TextureImage[0]);                  // Libera la struttura immagine
        
	}
	strcpy(tNew->nome_file, nome_file);         // la texture deve mantenere un riferimento al file di origine

	return Status;                              // Restituisce la variabile Status
};

void GLWVideo::SetupWorld()
{	
	float x, y, z, u, v;
	int numtriangles, i;
	TEXTURE *tPos;
	FILE *filein;
	char oneline[255];
	char nome_file[MAX_LENGHT_NOMEFILE];
	filein = fopen("data/world.txt", "rt");				// File da cui caricare i dati del mondo

	readstr(filein,oneline);
	sscanf(oneline, "NUMPOLLIES %d\n", &numtriangles);

	sector1.triangle = new TRIANGLE[numtriangles];
	sector1.numtriangles = numtriangles;
	for (int loop = 0; loop < numtriangles; loop++) // legge tutti i dati del file
	{
		for (int vert = 0; vert < 3; vert++)        // legge i tre vertici del triangolo
		{
			readstr(filein,oneline);
			sscanf(oneline, "%f %f %f %f %f", &x, &y, &z, &u, &v);
			sector1.triangle[loop].vertex[vert].x = -x;
			sector1.triangle[loop].vertex[vert].y = y;
			sector1.triangle[loop].vertex[vert].z = z;
			sector1.triangle[loop].vertex[vert].u = u;
			sector1.triangle[loop].vertex[vert].v = v;
		}
		// leggo il nome_file della texture, se specificato
		 if (fgets( oneline, 256, filein)==NULL)	return; 
		 if (oneline[0]=='#') // c' una texture
		 {			
			oneline[strlen(oneline)-1]='\0';
			strcpy(nome_file, &oneline[1]);
			// verifico se la texture  gi stata caricata
				for (i=0, tPos=texture_testa; (tPos!=NULL) && (strcmp(tPos->nome_file, nome_file)); i++, tPos=tPos->next);
				sector1.triangle[loop].n_texture=i; // in ogni caso, i indica l'indice della texture interesata
				
				if (tPos==NULL) // si deve creare la nuova texture
				{
					AddTexture(nome_file);
				}
			// altrimenti la carico e assegno il nuovo indice al sector1.triangle[loop].n_texture
		 }
		 else 
			 	sector1.triangle[loop].n_texture=-1;
	}
	fclose(filein);

	InitTextureVittoria();

	return;
};

void GLWVideo::SetupWorld_nff(const char *SrcFile, SECTOR_OBJ *ObjSect, float x, float y, float z, int flip, BOOL selezionabile, BOOL visible, BOOL blend) // selezionabile di default a TRUE - vedi protipo // idem visible
{	
	FILE *fSrc;
	TEXTURE *tPos;
	Oggetto *pos;
	char nome_file[MAX_LENGHT_NOMEFILE];	
	int i, j, k, tmp, q, vert;
	char num[20];
	char buffer[256], s[64]; // 256  la lunghezza max della riga (non dovrebbero 
			                    // capitare nemmeno righe oltre i 100 caratteri)
	
	// setto i fattori di posizione
		ObjSect->x=x/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSect->y=y/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSect->z=z/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSect->selezionabile=selezionabile;
		ObjSect->selezionato=FALSE;
		ObjSect->visible=visible;
		ObjSect->cursore=0;
		ObjSect->xrot=0;
		ObjSect->yrot=0;
		ObjSect->zrot=0;
		ObjSect->flip=flip;
		ObjSect->blend=blend;
		ObjSect->esplosione=0;


	// apro il file
		fSrc = fopen(SrcFile, "rt");		// File da cui caricare i dati del mondo

	// le prime tre righe del file contengono dati non necessari
		if (fgets( buffer, 255, fSrc)==NULL)
			return ;  // ERRORE NEL CARICAMENTO DA FILE
		if (fgets( buffer, 255, fSrc)==NULL)
			return ;  
		if (fgets( buffer, 255, fSrc)==NULL)  // riga inutile (nome oggetto)
			return ;  

	// inizio il ciclo fino alla fine del file: la prima riga dice   - tipo oggetto
	       //                                   la seconda           - vertici oggetto
		while (!feof(fSrc))
		{
			// inserisco l'elemento in testa alla lista // il nuovo elemento  dunque testa
				pos=new Oggetto;
				pos->next=ObjSect->oggetti;
				ObjSect->oggetti=pos;				
						
			// numero vertici
				if (fgets( buffer, 255, fSrc)==NULL) return ;
				buffer[strlen(buffer)-1]='\0';  // rendo la stringa leggibile (tolgo il '\n')
				
				pos->numVertex=(int)strtod(buffer, NULL);									
				pos->Vertex=new VERTEX[pos->numVertex];
				
			// ora converto le righe di coordinate
				for (i=0; i<pos->numVertex; i++) 
				{	
					
					if (fgets( buffer, 255, fSrc)==NULL) return ;
					buffer[strlen(buffer)-1]='\0';

					j=0;
					for (k=0; buffer[j]!=' '; j++, k++) 
						s[k]=buffer[j];
					s[k]='\0';
					pos->Vertex[i].x=(strtod(s, NULL)*(-1))/RIMPICCIOLISCO_IL_MONDO_DI;
					j++;

					for (k=0; buffer[j]!=' '; j++, k++)
						s[k]=buffer[j];
					s[k]='\0';
					pos->Vertex[i].y=strtod(s, NULL)/RIMPICCIOLISCO_IL_MONDO_DI;
					j++;

					for (k=0; (buffer[j]!=' '); j++, k++)
						s[k]=buffer[j];
					s[k]='\0';
					pos->Vertex[i].z=strtod(s, NULL)/RIMPICCIOLISCO_IL_MONDO_DI;
					
					if (buffer[++j]=='n')  // ricavo le coordinate della normale, se presenti
					{
						pos->Vertex[i].normale=true;

						for (j++; (buffer[j]!='m'); j++);
							j+=2;

						for (k=0; buffer[j]!=' '; j++, k++) 
							s[k]=buffer[j];
						s[k]='\0';
						pos->Vertex[i].nx=strtod(s, NULL)*(-1);				
						j++;

						for (k=0; buffer[j]!=' '; j++, k++)
							s[k]=buffer[j];
						s[k]='\0';
						pos->Vertex[i].ny=strtod(s, NULL);
						j++;

						for (k=0; (buffer[j]!=' '); j++, k++)
							s[k]=buffer[j];
						s[k]='\0';
						pos->Vertex[i].nz=strtod(s, NULL);
					}
					else   // altrimenti disattivo la normale
					{
						pos->Vertex[i].normale=false;
					}

					for (j++; (buffer[j]!='v'); j++);   // questa funzione disegna solo oggetti con texture
					j+=2;

					for (k=0; (buffer[j]!=' '); j++, k++)
						s[k]=buffer[j];
					s[k]='\0';
					pos->Vertex[i].u=strtod(s, NULL);
					j++;

					k=0;										
					for (; (buffer[j]!='\0'); j++, k++)
						s[k]=buffer[j];
					s[k]='\0';
					pos->Vertex[i].v=strtod(s, NULL)*(-1);			
				}

			// numero facce
				if (fgets( buffer, 255, fSrc)==NULL) return ;
				buffer[strlen(buffer)-1]='\0';  // rendo la stringa leggibile (tolgo il '\n')
				pos->numPoligoni=(int)strtod(buffer, NULL);

				pos->Poligoni=new POLIGONO[pos->numPoligoni];
				
			// ora copio i dati per la formazione dei lati dell'oggetto
			  // si tratta degli indici dei lati che formano ogni poligono
				for (i=0; i<pos->numPoligoni; i++)
				{
					if (fgets( buffer, 255, fSrc)==NULL)
						return ;  // ERRORE NEL CARICAMENTO DA FILE
					
					/* numero di vertici da leggere */
						q=0;
						for (tmp=0; (buffer[q]>='0')&&(buffer[q]<='9'); q++) num[tmp++]=buffer[q]; 
						num[tmp]='\0';
						pos->Poligoni[i].numVertex = (int)strtod(num, NULL);							 
						pos->Poligoni[i].IndexVertex = new int[pos->Poligoni[i].numVertex];  // alloco lo spazio di memoria necerrario a IndexVertex
						

						for (vert=0; vert<pos->Poligoni[i].numVertex; vert++)
						{
							/* vertice [vert] */	
								q++;
								for (tmp=0; (buffer[q]>='0')&&(buffer[q]<='9'); q++) num[tmp++]=buffer[q]; 
								num[tmp]='\0';
								pos->Poligoni[i].IndexVertex[vert] = (int)strtod(num, NULL);
						}

					    q+=10;
				
					// controllo se  indicata una texture
						if ((buffer[q]=='_')&&(buffer[q+1]=='s')&&(buffer[q+2]=='_'))
						{								
							buffer[strlen(buffer)-1]='\0';
							strcpy(nome_file, &buffer[q+3]);

							// verifico se la texture  gi stata caricata
								for (q=0, tPos=texture_testa; (tPos!=NULL) && (strcmp(tPos->nome_file, nome_file)); q++, tPos=tPos->next);
								pos->Poligoni[i].n_texture=q; // in ogni caso, i indica l'indice della texture interesata
								
								if (tPos==NULL) // si deve creare la nuova texture
								{
									AddTexture(nome_file);
								}						 		 
						}
						else
						{										 	
							strcpy(nome_file, "");
							pos->Poligoni[i].n_texture=-1;
						}
				}

				if (fgets( buffer, 255, fSrc)==NULL)  // vado a caporiga
				{
					fclose(fSrc);
					return ;  // ERRORE NEL CARICAMENTO DA FILE o riga vuota
				}
		}	

	// ora posso chiudere il file sorgente
		fclose(fSrc);

	return ;  // tutto OK

};

void GLWVideo::DestroyWorld(GLvoid)
{
	DestroyWorld_nff(&ObjSect1);
	
	if (is_scacchi)
	{
		DestroyWorld_nff(&ObjSectCur);

		for (int i=0; i<32; i++) DestroyWorld_nff(&ObjSectScacchi[i]);
	}
	
	/* Cancello le texture */	
		for (texture_pos = texture_testa; texture_pos!=NULL; texture_testa = texture_pos)
		{			
			glDeleteTextures(1, &texture_pos->texture);
			texture_pos = texture_pos->next;
			delete texture_testa;
		}

	/* cancello i comandi men e il font del testo */
		KillMenuCom();  
};

void GLWVideo::DestroyWorld_nff(SECTOR_OBJ *ObjSect)
{
	int i;//, *n;
//	VERTEX *v;
	POLIGONO *pol;

	/* distruggo gli oggetti */
		Oggetto *tmp, *p;	
		for (p=ObjSect->oggetti, tmp=p; p!=NULL; p=tmp)
		{
			tmp=tmp->next; // punta al successivo

			/* distruggo i vertici */
				delete p->Vertex; // il delete cancella tutto l'array
				p->Vertex=NULL;

			/* distruggo i poligoni */
				pol = p->Poligoni;
				for (i=0; i<p->numPoligoni; i++)	
				{					
					/* distruggo gli indici */					
						delete p->Poligoni[i].IndexVertex;
						p->Poligoni[i].IndexVertex=NULL;
					
					pol++;					
				}
				delete p->Poligoni;
				p->Poligoni=NULL;
			
			delete p;		
		}
		
		ObjSect->oggetti=NULL;   // questo me l'ero dimenticato.. che fatica capire che mancava!!! // 9/08/2007
};

GLvoid GLWVideo::InitTextureVittoria(GLvoid)
{
	TEXTURE *tPos;
	int i;
	for (i=0, tPos=texture_testa; (tPos!=NULL) && (strcmp(tPos->nome_file, "FINISH.BMP")); i++, tPos=tPos->next)
		;
	
	texture_vittoria=i;
}

GLvoid GLWVideo::ReSizeGLScene(GLsizei width, GLsizei height)		// Ridimensiona e Inizializza la Finestra GL 
{
	if (height==0)										// Evita una divisione per zero
	{
		height=1;										// Imposta l'Altezza a Uno
	}

	glViewport(0,0,width,height);						// Resetta la Viewport corrente

	glMatrixMode(GL_PROJECTION);						// Seleziona la Projection Matrix
	//glLoadIdentity();									// Resetta la Projection Matrix

	// Calcola l'Aspect Ratio della finestra
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Seleziona la Modelview Matrix
	glLoadIdentity();									// Resetta la Modelview Matrix
};



float ambientLight[] = { 0.7f, 0.7f, 0.7f, 1.0f };//{ 0.3f, 0.5f, 0.8f, 1.0f };
float diffuseLight[] = { 1.0f, 1.0f, 1.0f, 0.5f };//{ 0.25f, 0.25f, 0.25f, 1.0f };
float lightPosition[] = { 0.0f, 0.0f, 0.0f, 1.0f };//{ -10.0f, 8.0f, 10.0f, 1.0f };

float matAmbient[] = { 1.0f, 1.0f, 1.0f, 0.4f };
float matDiff[] = { 0.5f, 0.5f, 0.5f, 1.0f };


void GLWVideo::AddToWorld(char *filename, float x, float y, float z, int flip, int ID, BOOL blend)
{
	/* inserimento in testa */
		SECTOR_OBJ_LIST *p;	
		
		p = new SECTOR_OBJ_LIST;
		p->ID_Obj = ID;
		p->next = ObjSectList;
		p->ObjSect.blend=blend;
		p->ObjSect.oggetti=NULL;
		ObjSectList = p;
	
	SetupWorld_nff(filename, &ObjSectList->ObjSect, x, y, z, flip, FALSE, TRUE, blend);

};

SECTOR_OBJ *GLWVideo::GetObjectByID(int ID)
{
	/* ricerca */
		SECTOR_OBJ_LIST *p;
		for (p = ObjSectList; (p->ID_Obj!=ID)&&(p!=NULL); p=p->next);

	return &p->ObjSect;
};

void GLWVideo::RotateObjectID(int ID, GLfloat angolo, char asse)
{
	/* ricerca */
		SECTOR_OBJ_LIST *p;			
		for (p = ObjSectList; (p->ID_Obj!=ID)&&(p!=NULL); p=p->next);

	if (p!=NULL)
	{
		if (asse=='x')      p->ObjSect.xrot=angolo;
		else if (asse=='y') p->ObjSect.yrot=angolo;
		else if (asse=='z') p->ObjSect.zrot=angolo;
	}
};

void GLWVideo::ExplodeObjectID(int ID, GLfloat plus_explode)
{
	/* ricerca */
		SECTOR_OBJ_LIST *p;
		for (p = ObjSectList; (p->ID_Obj!=ID)&&(p!=NULL); p=p->next);

	p->ObjSect.esplosione+=plus_explode - p->ObjSect.esplosione/500;
};

void GLWVideo::ExplodeWorld(GLfloat plus_explode)
{
	ObjSect1.esplosione+=plus_explode+ObjSect1.esplosione;
};

void GLWVideo::MoveObjectID(int ID, GLfloat x, GLfloat y, GLfloat z)
{
	/* ricerca */
		SECTOR_OBJ_LIST *p;
		for (p = ObjSectList; (p->ID_Obj!=ID)&&(p!=NULL); p=p->next);

	p->ObjSect.x+=x;
	p->ObjSect.y+=y;
	p->ObjSect.z+=z;
};

void GLWVideo::DelFromWorld(int ID)
{
	/* ricerca */
		SECTOR_OBJ_LIST *p, *prec;
		p = ObjSectList;
		prec = NULL;
		for (; (p!=NULL) && (p->ID_Obj!=ID); prec=p, p=p->next);

		if (p!=NULL) // se ho trovato l'elemento
		{
			if (prec!=NULL) // se non siamo in testa
				prec->next = p->next;

			DestroyWorld_nff(&p->ObjSect);			
			delete p;
		}
};

int GLWVideo::InitOrDestroy(char *world, unsigned int luci, bool scacchi)
{	
	if (!InitGL(world, luci, scacchi))		// Inizializza la finestra GL creata
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}
	
	return TRUE;
};

int GLWVideo::InitGL(char *world, unsigned int luci, bool scacchi)			// Tutti i settaggi per OpenGL vengono fatti qui
{	
	if (!LoadGLTextures())								// Salta alla routine di caricamento Texture 
	{
		return FALSE;									// Se la Texture non  caricata restituisce FALSE
	}

	glEnable(GL_TEXTURE_2D);							// Abilita il Texture Mapping 
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Setta la funzione di Blending per la traslucenza
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Colore di sfondo Nero
	glClearDepth(1.0f);									// Setta il Depth Buffer 
	glDepthFunc(GL_LESS);								// Il tipo di Depth Test da fare
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
//	glEnable(GL_CULL_FACE);  // vedo la texture solo dal retro dell'oggetto
	glShadeModel(GL_SMOOTH);							// Abilita lo Smooth Shading
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Calcoli per la Prospettiva ideali

	if (menuBMPData!=NULL) free(menuBMPData);
	menuBMPData = LoadBitmapFile("data/immagini/Menu_lat.bmp", &menuBMPInfoHeader);	  // carico l'immagine di sfondo del men
	
	SetupWorld_nff(world, &ObjSect1, 0, 0, 0, false, FALSE);

	//set up material properties
//	glMaterialfv(GL_FRONT, GL_DIFFUSE, specular);
//	glMaterialfv(GL_FRONT, GL_SHININESS, shininess);


	is_scacchi = scacchi;
	if (scacchi)
	{
		Init_Modelli_Scacchi();

		SetupWorld_nff("data/ModScacchi/Cur.nff", &ObjSectCur,  0, 0, 0, false, TRUE, FALSE);
	}
	
	ObjSectCur.y=-1.4f/RIMPICCIOLISCO_IL_MONDO_DI;
	
	is_illuminato = luci;
	if (is_illuminato)
	{			
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 0);
		glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, 1);

	//	glColorMaterial(GL_BACK, GL_SHININESS);	
	//	glMaterialfv(GL_NONE, GL_AMBIENT, ambientLight);
		glMaterialfv(GL_BACK, GL_DIFFUSE, diffuseLight);
		if (is_illuminato==2)
			glEnable(GL_COLOR_MATERIAL);

		glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
		glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
		
		glEnable(GL_LIGHT0);
		glEnable(GL_LIGHTING);

	/*	GLfloat ambient[]={0.3f,0.3f,0.3f,1.0f};
		GLfloat diffuse[]={1.0f,1.0f,1.0f,1.0f};
		GLfloat lightpos[]={0.0f,0.0f,-2.0f,1.0f};
		glLightfv(GL_LIGHT1,GL_AMBIENT,ambient);
		glLightfv(GL_LIGHT1,GL_DIFFUSE,diffuse);
		glLightfv(GL_LIGHT1,GL_POSITION,lightpos);
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT1);*/
	}
	else
	{
		glDisable(GL_LIGHTING);
	}

	BuildFont();  // inizializzazione dei caratteri per la scrittura di testo

	return TRUE;										// Inizializzazione andata a buon fine
};

int GLWVideo::Init_Modelli_Scacchi()
{
	/*
		#define bre 1
		#define bdon 2
		#define balf 3
		#define bcav 4
		#define btor 5
		#define bped 6
		#define nre 7
		#define ndon 8
		#define nalf 9
		#define ncav 10
		#define ntor 11
		#define nped 12
	*/
	int i=0, j;
	short int n;
	float x, y, z, width;

	x=1.0f;
	y=0.0f;
	z=-1.4f;
	width=1.4f;

	SetupWorld_nff("data/ModScacchi/BTor.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BCav.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BAlf.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BDon.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BRe.nff",  &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BAlf.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BCav.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BTor.nff", &ObjSectScacchi[i],  x-(((i++)-1)*width), y, z, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);
	SetupWorld_nff("data/ModScacchi/BPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-8)*width), y, z+width, false);

	z=z+6*width; // vado dall'altra parte della scacchiera

	SetupWorld_nff("data/ModScacchi/NTor.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NCav.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NAlf.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NDon.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NRe.nff",  &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NAlf.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NCav.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NTor.nff", &ObjSectScacchi[i],  x-(((i++)-1-16)*width), y, z+width, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);
	SetupWorld_nff("data/ModScacchi/NPe.nff" , &ObjSectScacchi[i],  x-(((i++)-1-24)*width), y, z, true);

	/* inizializzo la scacchiera */
		n=0;
		for (i=1; i<=2; i++)
			for (j=1; j<=8; j++)    // bre==4
				scac[j][i]=n++;
	
		for (i=3; i<=6; i++)
			for (j=1; j<=8; j++)
				scac[j][i]=-1;
	
		for (i=8; i>=7; i--)
			for (j=1; j<=8; j++)    // nre==20
				scac[j][i]=n++;
		

		ObjSectScacchi[0].selezionato=TRUE;

	return TRUE;
}

int GLWVideo::DrawGLScene(GLvoid)									// Qui  dove farete tutti i disegni
{
	if (!fpsActive) 	
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Pulisce lo schermo e il Depth Buffer	
	
	glLoadIdentity();									// Resetta la View

	GLfloat x_m, y_m, z_m, u_m, v_m;
	GLfloat xtrans = -xpos;
	GLfloat ztrans = -zpos;
	GLfloat ytrans = -walkbias-0.25f-ypos;
	GLfloat sceneroty = 360.0f - yrot;

	int numtriangles, i;

	glRotatef(lookupdown,1.0f,0,0);
	glRotatef(sceneroty,0,1.0f,0);
	
	glTranslatef(xtrans, ytrans, ztrans);
	
	numtriangles = sector1.numtriangles;
	
	// Elabora ogni Triangolo
	glColor3ub(255, 255, 255); // colori texture originali

	for (int loop_m = 0; loop_m < numtriangles; loop_m++)
	{
		if (sector1.triangle[loop_m].n_texture!=-1)  // se c' una texture la carico
		{
			for (i=0, texture_pos=texture_testa; i<sector1.triangle[loop_m].n_texture; i++, texture_pos=texture_pos->next);    // cerco la texture interessata
			glBindTexture(GL_TEXTURE_2D, texture_pos->texture);
		}

		glBegin(GL_TRIANGLES);   // tutto questo dovr essere modificato per caricare una lista di triangoli
			glNormal3f( 0.0f, 0.0f, 1.0f);
			x_m = sector1.triangle[loop_m].vertex[0].x;
			y_m = sector1.triangle[loop_m].vertex[0].y;
			z_m = sector1.triangle[loop_m].vertex[0].z;
			u_m = sector1.triangle[loop_m].vertex[0].u;
			v_m = sector1.triangle[loop_m].vertex[0].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[1].x;
			y_m = sector1.triangle[loop_m].vertex[1].y;
			z_m = sector1.triangle[loop_m].vertex[1].z;
			u_m = sector1.triangle[loop_m].vertex[1].u;
			v_m = sector1.triangle[loop_m].vertex[1].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[2].x;
			y_m = sector1.triangle[loop_m].vertex[2].y;
			z_m = sector1.triangle[loop_m].vertex[2].z;
			u_m = sector1.triangle[loop_m].vertex[2].u;
			v_m = sector1.triangle[loop_m].vertex[2].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);			
		glEnd();
	}

		
	return TRUE;										// Tutto OK
};

int GLWVideo::DrawGLScene_nff(SECTOR_OBJ *ObjSect)									// Qui  dove farete tutti i disegni
{                                                           
	if (ObjSect->visible)
	{	
		glLoadIdentity();									// Resetta la View

		GLfloat x_m, y_m, z_m, u_m, v_m, x_explode, y_explode, z_explode;
		GLfloat xtrans = -xpos;
		GLfloat ztrans = -zpos;
		GLfloat ytrans = -walkbias-0.25f-ypos;
		GLfloat sceneroty = 360.0f - yrot/* - ObjSect->yrot*/;

		int i;
		Oggetto *pos;

		glRotatef(lookupdown,1.0f,0,0);			
		glRotatef(sceneroty,0,1.0f,0); // include gi la rotazione in y	
					
		// fattori di traslazione
			float tx, ty, tz;
			tx=ObjSect->x;
			ty=ObjSect->y;
			tz=ObjSect->z;
							
		glTranslatef(xtrans+tx, ytrans+ty, ztrans+tz);

		glLightfv(GL_LIGHT0, GL_POSITION, lightPosition );

		glRotatef(ObjSect->xrot, 1.0f, 0, 0);  // rotazione in y
	//	if (ObjSect->flip==1) 
	//	{			
	//		glRotatef(ObjSect->xrot+180, 0, 1.0f, 0);  // rotazione in x	
	//	}
	//	else 
			glRotatef(ObjSect->yrot, 0, 1.0f, 0);  // rotazione in x
		glRotatef(ObjSect->zrot, 0, 0, 1.0f);  // rotazione in z
	

		/* Setta i colori a seconda del tipo di selezione */
		bool illumina=false;
		if ((ObjSect->cursore==0)||(ObjSectCur.selezionato==FALSE))      // se non si tratta del cursore // molto probabile
		{			
			if (ObjSect->selezionato)//&& (((CurZ>=ObjSect->z - 0.1f)&&(CurZ<=ObjSect->z + 0.1f)&&(CurX>=ObjSect->x - 0.1f)&&(CurX<=ObjSect->x + 0.1f))||(ObjSect->selezionato)) )
			{
				glDisable(GL_LIGHTING);
				if (is_illuminato) illumina=true;
				rgb_var+=5;
				glColor3ub((float(rgb_var))/5, float(rgb_var), (float(rgb_var))/2); // colori texture originali				
			}
			else
			{				
				glColor3ub(255, 255, 255); // colori texture originali
			}
		}
		else if (ObjSect->cursore==1) // mossa non permessa // rosso
		{
			glDisable(GL_LIGHTING);
			if (is_illuminato) illumina=true;
			glColor3ub(255, 0, 0);
		}
		else if (ObjSect->cursore==2) // mossa permessa     // blu
		{
			glDisable(GL_LIGHTING);
			if (is_illuminato) illumina=true;
			glColor3ub(0, 50, 255);
		}
	
	int vertex1, vertex2, vertex3;
	float aggiunta;

	glPushMatrix();		
		aggiunta=0.75f;
		// Elabora ogni Poligono
		for (pos=ObjSect->oggetti; pos!=NULL; pos=pos->next)
		{			
			if ((ObjSect->blend)||(blend)) glEnable(GL_BLEND);
			else glDisable(GL_BLEND);

			for (int loop_m = 0; loop_m<pos->numPoligoni; loop_m++)
			{
				if (pos->Poligoni[loop_m].n_texture!=-1)  // se c' una texture la carico
				{
					for (i=0, texture_pos=texture_testa; (texture_pos!=NULL)&&(i<pos->Poligoni[loop_m].n_texture); i++, texture_pos=texture_pos->next);    // cerco la texture interessata
					if (texture_pos!=NULL) glBindTexture(GL_TEXTURE_2D, texture_pos->texture);							
				}

				vertex1 = 0;
				vertex2 = 1;
				vertex3 = 2;		
				
				if (ObjSect->esplosione!=0)
				{
					x_explode=((loop_m%2 + loop_m%7 + loop_m%4 +1) * ObjSect->esplosione+1) /10 + aggiunta;
					if (loop_m%2) x_explode=x_explode*(-1) +2*aggiunta;
					y_explode=((loop_m%6 + loop_m%2 + loop_m%17 +1) * ObjSect->esplosione+1) /10 + aggiunta;
				//	if (loop_m%5) y_explode*=-1;
					z_explode=((loop_m%9 + loop_m%3 + loop_m%4 +1) * ObjSect->esplosione+1) /10 + aggiunta;
					if (loop_m%5) z_explode=z_explode*(-1) +2*aggiunta;
				}
				else
				{
					x_explode=1;
					y_explode=1;
					z_explode=1;
				}

				for(; vertex2<pos->Poligoni[loop_m].numVertex-1; vertex2++, vertex3++)
				{		
				

				glBegin(GL_TRIANGLES);
					
						if (pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].normale)
							glNormal3f(pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].nx,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].ny,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].nz);

						x_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].x*x_explode;
						y_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].y*y_explode;
						z_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].z*z_explode;
						u_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].u;
						v_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex1]].v;
						if (ObjSect->flip==1)
						{						
							z_m*=-1;
							z_m+=aggiunta;							
						}
						
						glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);

						if (pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].normale)
							glNormal3f(pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].nx,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].ny,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].nz);

						
						x_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].x*x_explode;
						y_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].y*y_explode;
						z_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].z*z_explode;
						u_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].u;
						v_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex2]].v;
						if (ObjSect->flip==1)
						{					
							z_m*=-1;
							z_m+=aggiunta;
						}
						glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);

						if (pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].normale)
							glNormal3f(pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].nx,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].ny,
									   pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].nz);
						
						x_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].x*x_explode;
						y_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].y*y_explode;
						z_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].z*z_explode;
						u_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].u;
						v_m = pos->Vertex[pos->Poligoni[loop_m].IndexVertex[vertex3]].v;
						if (ObjSect->flip==1)
						{						
							z_m*=-1;
							z_m+=aggiunta;
						}
						glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);						
					
				glEnd();

				}		
			}
		}		
	glPopMatrix();
	if (illumina) glEnable(GL_LIGHTING);
	}

		
	return TRUE;										// Tutto OK
};

GLvoid GLWVideo::KillGLWindow(GLvoid)								// Distrugge in modo corretto la finestra
{
	if (fullscreen)										// Siamo in modalit Schermo Intero?
	{
		ChangeDisplaySettings(NULL,0);					// Se s torna alla modalit Desktop
		ShowCursor(TRUE);								// Mostra il puntatore del Mouse 
	}

	if (hRC)											// Esiste un Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// E' possibile rilasciare il DC Context e l'RC Context?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// E' possibile cancellare l'RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Setta l'RC a NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// E' possibile rilasciare il DC?
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Setta il DC a NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// E' possibile distruggere la Finestra?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Setta hWnd a NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// E' possibile deregistrare la Classe?
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Setta hInstance a NULL
	}
};

/*	Questo codice crea la Finestra OpenGL.  I parametri sono:			     	  *
 *	title			- Titolo della Finestra									      *
 *	width			- Larghezza della Finestra GL o della modalit Schermo Intero *
 *	height			- Altezza della Finestra GL o della modalit Schermo Intero   *
 *	bits			- Numero di Bits da usare per il colore (8/16/24/32)	      *
 *	fullscreenflag	- Usa la modalit Schermo Intero (TRUE) o Finestra (FALSE)    */
 
BOOL GLWVideo::CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Contiene i risultati dopo la ricerca 
	WNDCLASS	wc;						// Struttura Windows Class 
	DWORD		dwExStyle;				// Stile esteso della finestra
	DWORD		dwStyle;				// Stile della finestra 
	RECT		WindowRect;				// Rettangolo della finestra. Valori Superiore Sinistro/Inferiore Destro
	WindowRect.left=(long)0;			// Setta il valore Sinistro a 0
	WindowRect.right=(long)width;		// Setta il valore Destro alla Larghezza richiesta
	WindowRect.top=(long)0;				// Setta il valore Superiore a 0
	WindowRect.bottom=(long)height;		// Setta il valore Inferiore all'Altezza richiesta

	fullscreen=fullscreenflag;			// Setta il flag globale Fullscreen (schermo intero o modalit finestra)

	hInstance			= GetModuleHandle(NULL);				// Tiene l'istanza per la Finestra
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Ridisegna al ridimensionamento, e DC personale per la Finestra.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// Procedure di gestione dei Messaggi (WndProc)
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Setta l'Istanza
	wc.hIcon			= LoadIcon(NULL, /*IDI_ICON1*/IDI_WINLOGO);			// Carica l'icona di Default
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Carica il puntatore del mouse a freccia
	wc.hbrBackground	= NULL/*(HBRUSH)COLOR_BTNSHADOW*/;						// Non  richiesto uno sfondo per GL
	wc.lpszMenuName		= NULL;									// Non vogliamo un menu
	wc.lpszClassName	= "OpenGL";								// Setta il nome della Classe

	if (!RegisterClass(&wc))									// Prova a registrare la Classe Finestra (WC)
	{
		MessageBox(NULL,"Errore nella creazione della finestra.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Restituisce FALSE
	}
	
	if (fullscreen)												// Provare ad attivare la modalit schermo intero?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Si assicura che la memoria sia pulita
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Dimensione della struttura Devmode 
		dmScreenSettings.dmPelsWidth	= width;				// Larghezza dello schermo selezionata
		dmScreenSettings.dmPelsHeight	= height;				// Altezza dello schermo selezionata
		dmScreenSettings.dmBitsPerPel	= bits;					// Bits Per Pixel selezionati
		dmScreenSettings.dmFields=/*DM_BITSPERPEL|*/DM_PELSWIDTH|DM_PELSHEIGHT;

		// Prova a settare la modalit selezionata e ottiene i risultati.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// Se la modalit fallisce, offre due opzioni.  Chiudere o usare la modalit finestra.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Seleziona la modalit finestra.  Fullscreen = FALSE
			}
			else
			{
				// Una finestra di messaggio avvisa l'utente che il programma sar chiuso.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Siamo in modalit schermo intero?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Stile esteso della Finestra
		dwStyle=WS_POPUP;										// Stile della Finestra
		ShowCursor(FALSE);										// Nasconde il puntatore del Mouse 
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Stile esteso della Finestra
		dwStyle=WS_OVERLAPPEDWINDOW;							// Stile della Finestra
		ShowCursor(TRUE);
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Aggiusta la Finestra alla dimensione reale richiesta

	// Crea la Finestra
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Stile esteso per la Finestra
								"OpenGL",							// Nome della Classe
								title,								// Titolo della Finestra
								dwStyle |							// Stile della Finestra definito
								WS_CLIPSIBLINGS |					// Stile Finestra richiesto
								WS_CLIPCHILDREN,					// Stile Finestra richiesto
								0, 0,								// Posizione della Finestra
								WindowRect.right-WindowRect.left,	// Calcola la Larghezza della Finestra
								WindowRect.bottom-WindowRect.top,	// Calcola l'Altezza della Finestra
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Non passa nulla a WM_CREATE
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd dice a Windows come voi pensate che debba essere
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Dimensione del descrittore del Pixel Format 
		1,											// Numero di versione
		PFD_DRAW_TO_WINDOW |						// Il formato deve supportare Window
		PFD_SUPPORT_OPENGL |						// Il formato deve supportare OpenGL
		PFD_DOUBLEBUFFER,							// Deve supportare il float Buffering
		PFD_TYPE_RGBA,								// Richiede un formato RGBA 
		bits,										// Seleziona la profondit di colore
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Piano principale di disegno
		0,											// Riservato
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Possiamo ottenere un Device Context?
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Windows pu trovare un Pixel Format che coincide con quello richiesto?
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// E' possibile settare il Pixel Format?
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// E' possibile ottenere un Rendering Context?
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Prova ad attivare il Rendering Context
	{
		KillGLWindow();								// Ripristina il Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Restituisce FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Mostra la finestra
	SetForegroundWindow(hWnd);						// Priorit molto alta 
	SetFocus(hWnd);									// Setta l'input focus della tastiera sulla Finestra
	ReSizeGLScene(width, height);					// Setta la prospettiva per lo schermo GL 
	
	return TRUE;									// Tutto OK
};

int GLWVideo::InitWorld(char *s)
{
	// Crea la Finestra OpenGL 
	if (!CreateGLWindow(s, Screen_X, Screen_Y, Screen_BITS, fullscreen))
	{
		return FALSE;									// Chiude se la Finestra non  stata creata
	}
	Wnd_Name=s;

	return TRUE;
};

int GLWVideo::DrawAll()
{	
	//float lightPosition[] = { -50.0f-xpos, 10.0f-ypos, 50.0f-zpos, 1.0f };
//	float lightPosition[] = { -50.0f, 10.0f, 50.0f, 1.0f };

	//if ((!fpsActive)&&(!testoActive)&&(!))
	//	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Pulisce lo schermo e il Depth Buffer	
	
//	glLoadIdentity();
	// setto la pos della luce
	

	DrawGLScene_nff(&ObjSect1);	
	if (is_scacchi)
	{		
		for (int i=0; i<32; i++) DrawGLScene_nff(&ObjSectScacchi[i]);
	}
	else
	{
		glDisable(GL_TEXTURE_GEN_S);							// Enable Texture Coord Generation For S
		glDisable(GL_TEXTURE_GEN_T);	
	}
	DrawGLScene_nff(&ObjSectCur);

	/* oggetti aggiuntivi */
		SECTOR_OBJ_LIST *p;
		for (p=ObjSectList; p!=NULL; p=p->next)
			DrawGLScene_nff(&p->ObjSect);

//	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
	
	return TRUE;
}

int GLWVideo::Muovi(unsigned int m)
{
		float Ax, Ay, Az, Awidth;	 // diventeranno #define
		Ax=ICurX;
		Ay=0.0f;
		Az=ICurZ;
		Awidth=QUAD_W;
		
		int da_x  = ((m%10000)-(m%1000))/1000;
		int da_y  = ((m%1000) -(m%100))/100;
		int Mat_x = ((m%100)-(m%10))/10;
		int Mat_y = (m%10);

	/* muovo graficamente il pezzo */
		short int iniz=scac[da_x][da_y];  
		short int fin= scac[Mat_x][Mat_y];
		mossa=0;
		tmpMossa=0;			
		ObjSectCur.visible=FALSE;
		ObjSectCur.selezionato=FALSE;
		ObjSectScacchi[iniz].x=(Ax-(Awidth*(Mat_x-1)))/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSectScacchi[iniz].z=(Az+(Awidth*(Mat_y-1)))/RIMPICCIOLISCO_IL_MONDO_DI;
	/* aggiorno la matrice scac */
		scac[da_x][da_y]=-1;  // posto lasciato == vuoto
		scac[Mat_x][Mat_y]=iniz;  


	if (fin>=0) // se un pezzo viene mangiato diventa invisibile // non libero la memoria, per ora
	{
		sto_mangiando=false; // ho gia mangiato
		ObjSectScacchi[fin].visible=FALSE;
		ObjSectScacchi[fin].x=-1000;
		ObjSectScacchi[fin].y=-1000;
		ObjSectScacchi[fin].z=-1000;
		ObjSectScacchi[fin].esplosione=0;  // riposto il pezzo allo stato solido
		if (fin==20)
			return 1;
		else if (fin==4)
			return 2;
	}
	return 0;
}

int GLWVideo::Disegna(char *com)
{
	/* se devo scrivere le fps */	
	/*	if (fpsActive) 
		{
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Pulisce lo schermo e il Depth Buffer
			glLoadIdentity();									// Resetta la Modelview Matrix corrente
			glTranslatef(0.0f,0.0f,-1.0f);	
			glRasterPos2f(-0.45f+0.05f*float(cos(cnt1)), 0.32f*float(sin(cnt1)));		
 			glPrint("fps = %i", fps);	// Scrive il testo GL sullo schermo	
		}
*/		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Pulisce lo schermo e il Depth Buffer			
		glLoadIdentity();									// Resetta la Modelview Matrix corrente
		
		if ((testoActive)||(mostraAvversario)||(mostraImgStage)||(riconoscimenti))
		{
		//	active=false;		
			glDisable(GL_TEXTURE_2D);
		//	is_illuminato=false;
		//	glDisable(GL_LIGHTING);
		//	glDisable(GL_LIGHT0);
		//	glDisable(GL_COLOR_MATERIAL);
			
			MENU_COM *mt;
			int riga=1;
			
			
			if (riconoscimenti)
			{
				active=false;

				glTranslatef(0.0f,0.0f,-3.2f);				
				glColor3f(1.0f, 1.0f, 1.0f);   // colore

				for (mt=menuCom; mt!=NULL; mt=mt->next, riga++)
				{
					if (mt==selCom)
						glRasterPos2f(-1.70f+0.05f*float(cos(cnt1)), 1.10f+0.32f*float(sin(cnt1))-(riga*0.05f));  // posiziona il "cursore" (una frase alla Word)		
					else
						glRasterPos2f(-1.70f+0.05f*float(cos(cnt1)), 1.10f+0.32f*float(sin(cnt1))-(riga*0.05f));  // posiziona il "cursore" (una frase alla Word)		
					
					glPrint(mt->testo, &base);        // Scrive il testo GL sullo schermo
				}
			}
			else
			{
				active=true;

				glTranslatef(0.0f,0.0f,-1.0f);				
				glColor3f(0.0f, 0.0f, 0.0f);   // colore

				if (testoActive)
				{
					for (mt=menuCom; mt!=NULL; mt=mt->next, riga++)
					{
						if (mt==selCom)
							glRasterPos2f(-0.42f+0.05f*float(cos(cnt1)), 0.25f+0.32f*float(sin(cnt1))-(riga*0.05f));  // posiziona il "cursore" (una frase alla Word)		
						else
							glRasterPos2f(-0.45f+0.05f*float(cos(cnt1)), 0.25f+0.32f*float(sin(cnt1))-(riga*0.05f));  // posiziona il "cursore" (una frase alla Word)		
						
						glPrint(mt->testo, &base);        // Scrive il testo GL sullo schermo
					}
					
					blend=true;
				}
				else
					blend=false;

				if (chatSuoTesto[0]!='\0')
				{
					glRasterPos2f(-0.42f+0.05f*float(cos(cnt1)), 0.37f+0.32f*float(sin(cnt1)));
					glPrint(&chatSuoTesto[0], &chat);
				}
				if (chatMioTesto[0]!='\0')
				{
					glRasterPos2f(-0.42f+0.05f*float(cos(cnt1)), 0.35f+0.32f*float(sin(cnt1)));
					glPrint(&chatMioTesto[0], &chat);
				}
							
				if (mostraAvversario)
				{
					glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
					//glRasterPos2f(0.40f,0.25f);
					glRasterPos2f(0.34f+0.05f*float(cos(cnt1)), 0.29f+0.32f*float(sin(cnt1))-(riga*0.05f));
					if (mostraAvversario==1)
						glDrawPixels(imgAvvNormHead.biWidth, imgAvvNormHead.biHeight, GL_RGB, GL_UNSIGNED_BYTE, imgAvvNorm);
					else if (mostraAvversario==2)
						glDrawPixels(imgAvvAttaccaHead.biWidth, imgAvvAttaccaHead.biHeight, GL_RGB, GL_UNSIGNED_BYTE, imgAvvAttacca);
					else if (mostraAvversario==3)
						glDrawPixels(imgAvvSubisceHead.biWidth, imgAvvSubisceHead.biHeight, GL_RGB, GL_UNSIGNED_BYTE, imgAvvSubisce);
				}

				if (mostraImgStage)
				{
					glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
					//glRasterPos2f(0.40f,0.25f);
					glRasterPos2f(0.13f+0.05f*float(cos(cnt1)), 0.29f+0.32f*float(sin(cnt1))-(riga*0.05f));			
					glDrawPixels(imgStageHead.biWidth, imgStageHead.biHeight, GL_RGB, GL_UNSIGNED_BYTE, imgStage);			
				}

				if (testoActive)
				{
					/* Disegno lo sfondo del men */
						glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
						glRasterPos2f(-0.55f,-0.25f);
						glDrawPixels(menuBMPInfoHeader.biWidth, menuBMPInfoHeader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, menuBMPData);
						glRasterPos2f(-0.20f,-0.25f);
						glDrawPixels(menuBMPInfoHeader.biWidth, menuBMPInfoHeader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, menuBMPData);
						glRasterPos2f(-0.55f,-0.40f);
						glDrawPixels(menuBMPInfoHeader.biWidth, menuBMPInfoHeader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, menuBMPData);
						glRasterPos2f(-0.20f,-0.40f);
						glDrawPixels(menuBMPInfoHeader.biWidth, menuBMPInfoHeader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, menuBMPData);
				}
			}

		/*		if (mostraAvversario)
			{			
			//	glDisable(GL_TEXTURE_2D);
			//	glTranslatef(0.0f,0.0f,-1.0f);	
				
				glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
				glRasterPos2f(-0.55f,-0.25f);
				glDrawPixels(imgAvvNormHead.biWidth, imgAvvNormHead.biHeight, GL_RGB, GL_UNSIGNED_BYTE, imgAvvNorm);
				
			//	glEnable(GL_TEXTURE_2D);
			}*/
			glEnable(GL_TEXTURE_2D);
		}
		else
		{
			active=true;	
			blend=false;
		}
	//		active=true;			
	//	}

	
	if (ObjSectCur.selezionato) ObjSectCur.visible=TRUE;

	if ((active && !DrawAll())/* || (keys[VK_ESCAPE])*/)	// Attivo?  E' stato ricevuto un messaggio chiudi?
	{
		return TRUE;							// ESC o DrawGLScene hanno segnalato la chiusura
	}
	else									// Non  il momento di chiudere, quindi aggiorna lo schermo
	{	
		SwapBuffers(hDC);					// Scambia i Buffer (float Buffering)
		
		if (scriviChat)  // non posso giocare e scrivere contemporaneamente
		{
			if (chatMioTestoLength<MAX_LENGTH_CHAT_BUFFER)
			{
				bool b=FALSE;
				for (char ch='A'; ch<='Z'; ch++)
				{
					if (keys[ch])
					{
						if (tasto_premuto!=ch)
						{
							chatMioTesto[chatMioTestoLength++]=ch;
							chatMioTesto[chatMioTestoLength]='\0';
							tasto_premuto=ch;
						}
						
						b=TRUE;
					//	break;
					}			
				}
				for (ch='0'; ch<='9'; ch++)
				{
					if (keys[ch])
					{
						if (tasto_premuto!=ch)
						{
							chatMioTesto[chatMioTestoLength++]=ch;
							chatMioTesto[chatMioTestoLength]='\0';
						}
					
						b=TRUE;
					//	break;
					}			
				}
				if (!b) tasto_premuto=0;
				
				if (keys[VK_SPACE] && !fSPACE)
				{
					chatMioTesto[chatMioTestoLength++]=' ';
					chatMioTesto[chatMioTestoLength]='\0';
				}
				if (!keys[VK_SPACE])
					fSPACE=FALSE;

				if ((keys[VK_RETURN]) && (com!=NULL))
					*com='p';    // invio il messaggio
			}
			if ((keys[VK_BACK])&&(chatMioTestoLength>0)&&(!fW))
			{
				chatMioTesto[--chatMioTestoLength]='\0';
				fW=TRUE;
			}
			
			if (!keys[VK_BACK]) fW=FALSE;  // utilizzo fW per indicare la pressione di backspace
		}
		else if (com==NULL) // per evitare errori
		{
		/*	if (keys['F'] && !fp)
			{		
				fp=TRUE;

				fpsActive=!fpsActive;
			}

			if (!keys['F'])
			{
				fp=FALSE;			
			}
*/
			if (keys[VK_PRIOR])
			{
			//	z-=0.02f;
			}

			if (keys[VK_NEXT])
			{
				//z+=0.02f;
				//xpos -= (float)sin(heading*piover180) * 0.05f / Rallentamento;
			}

			if (keys[VK_PRIOR])
			{
			//	lookupdown-= 1.0f;
			}

			if (keys[VK_NEXT])
			{
			//	lookupdown+= 1.0f;
			}

			if (keys[VK_F1])						// Punto di vista 1
			{
				lookupdown = 30.0f;	
				ypos=7.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				xpos=-5.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				zpos=-8.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
				yrot = 180.0f;	

				keys[VK_F1]=FALSE;
				controllaOrientamento();
			}

			if (keys[VK_F2])						// Punto di vista 2
			{
				lookupdown = 30.0f;	
				ypos=7.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				xpos=-5.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				zpos=+18.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
				yrot = 0.0f;
				
				keys[VK_F2]=FALSE;
				controllaOrientamento();
			}

			if (keys[VK_F3])						// Punto di vista 3
			{
				lookupdown = 30.0f;	
				ypos=7.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				xpos=-18.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				zpos=5.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
				yrot = 270.0f;
				
				keys[VK_F3]=FALSE;
				controllaOrientamento();
			}

			if (keys[VK_F4])						// Punto di vista 4
			{
				lookupdown = 30.0f;	
				ypos=7.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				xpos=8.0f/RIMPICCIOLISCO_IL_MONDO_DI;
				zpos=5.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
				yrot = 90.0f;

				keys[VK_F4]=FALSE;
				controllaOrientamento();
			}
				
			if (keys[VK_NUMPAD8])						// E' stato premuto F1?
			{						
				avanti = 100/RIMPICCIOLISCO_IL_MONDO_DI;
			}

			if (keys[VK_NUMPAD2])						// E' stato premuto F1?
			{
				avanti = -100/RIMPICCIOLISCO_IL_MONDO_DI;
			}

			if (keys[VK_NUMPAD4])						// E' stato premuto F1?
			{
				heading += (100.0f/Rallentamento)/RIMPICCIOLISCO_IL_MONDO_DI;
				yrot = heading;
				controllaOrientamento();				
			}

			if (keys[VK_NUMPAD6])						// E' stato premuto F1?
			{
				heading -= (100.0f/Rallentamento)/RIMPICCIOLISCO_IL_MONDO_DI;
				yrot = heading;
				controllaOrientamento();			
			}

			if (keys[VK_NUMPAD7])						// E' stato premuto F1?
			{
				ypos+=(0.1f/RIMPICCIOLISCO_IL_MONDO_DI);				
			}

			if (keys[VK_NUMPAD1])						// E' stato premuto F1?
			{
				ypos-=(0.1f/RIMPICCIOLISCO_IL_MONDO_DI);				
			}

			if (STATE == 1/*SWAIT_ME*/) // eventi di movimento del cursore
			{
				if (keys['W'] && !fW)
				{	
					if (DirezioneComandi==1)		muoviCurSu();
					else if (DirezioneComandi==2)	muoviCurGiu();
					else if (DirezioneComandi==3)   muoviCurSin();
					else if (DirezioneComandi==4)   muoviCurDes();
			
					
					fW=TRUE;
				}
				if (!keys['W'])
					fW=FALSE;

				if (keys['S'] && !fS)
				{
					if (DirezioneComandi==1)		muoviCurGiu();
					else if (DirezioneComandi==2)	muoviCurSu();
					else if (DirezioneComandi==3)   muoviCurDes();
					else if (DirezioneComandi==4)   muoviCurSin();			

					fS=TRUE;
				}
				if (!keys['S'])
					fS=FALSE;

				if (keys['D'] && !fD)
				{			
					if (DirezioneComandi==1)		muoviCurDes();
					else if (DirezioneComandi==2)	muoviCurSin();
					else if (DirezioneComandi==3)   muoviCurSu();
					else if (DirezioneComandi==4)   muoviCurGiu();

					fD=TRUE;
				}
				if (!keys['D'])
					fD=FALSE;

				if (keys['A'] && !fA)
				{
					if (DirezioneComandi==1)		muoviCurSin();
					else if (DirezioneComandi==2)	muoviCurDes();
					else if (DirezioneComandi==3)   muoviCurGiu();
					else if (DirezioneComandi==4)   muoviCurSu();

					fA=TRUE;
				}	

				if (!keys['A'])
					fA=FALSE;		

				if (!keys[VK_SPACE])
					fSPACE=FALSE;

				if (keys[VK_SPACE] && !fSPACE)
				{					
					int n=scac[Mat_x][Mat_y];			
					
					if (ObjSectCur.selezionato)  // seleziono la mossa - o deseleziono il pezzo scelto
					{
						if (ObjSectScacchi[n].selezionato==2) // deseleziono il pezzo
						{
							ObjSectScacchi[n].selezionato=1;
							ObjSectCur.selezionato=FALSE;
						}
						else
						{     // se la mossa  effettuabile la salvo in mossa(il main far il seguito), altrimenti niente.
							if (ObjSectCur.cursore==2)   // se la mossa  permessa
							{
								mossa=tmpMossa;
								ObjSectCur.visible=FALSE;
							}

							ObjSectScacchi[scac[da_x][da_y]].selezionato=0;
							ObjSectCur.selezionato=FALSE;
						//	ObjSectCur.visible=FALSE;
							//else                               // *** eseguo un suono, ad esempio ***
						}
					}
					else if ( (n>=0) && (n<=31) && (ObjSectScacchi[n].selezionabile) ) // seleziono il pezzo da muovere
					{				
						if (ObjSectScacchi[n].selezionato!=2) 
						{	
							da_x=Mat_x;
							da_y=Mat_y;

							mossa = Mat_y + (Mat_x * 10);
							tmpMossa=mossa;
							ObjSectScacchi[n].selezionato=2;
							ObjSectCur.selezionato=TRUE;
							ObjSectCur.x=(ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;				
							ObjSectCur.z=(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;					
						}
						else // *** in teoria questo else non serve ***  gi compensato da 	if (ObjSectScacchi[n].selezionato==2) - qui sopra
						{
							mossa=0;
							tmpMossa=0;
							ObjSectScacchi[n].selezionato=1;					
						}
					}
					fSPACE=TRUE;
				}
			}
		}
		else  // se ci si trova in un men, o comunque in qualcosa diverso dallo scenario di gioco
		{
			if (keys['W'] && !fW)
			{					
				fW=TRUE;
				*com = 'w';
			}
			if (!keys['W'])
				fW=FALSE;

			if (keys['S'] && !fS)
			{			
				fS=TRUE;
				*com = 's';
			}
			if (!keys['S'])
				fS=FALSE;

			if (keys['D'] && !fD)
			{						
				fD=TRUE;
				*com = 'd';
			}
			if (!keys['D'])
				fD=FALSE;

			if (keys['A'] && !fA)
			{			
				fA=TRUE;
				*com = 'a';
			}	

			if (!keys['A'])
				fA=FALSE;		

			if (keys[VK_SPACE] && !fSPACE)
			{
				fSPACE=TRUE;
				*com = ' ';
			}

			if (!keys[VK_SPACE])
				fSPACE=FALSE;
		}

		/* movimento */			
			if (avanti!=0)
			{
				xpos -= ((float)sin(heading*piover180) * (avanti*0.08f) / Rallentamento);//*collidono;
				zpos -= ((float)cos(heading*piover180) * (avanti*0.08f) / Rallentamento);//*collidono;
				
				avanti=0;
			}
	}
//}
	return FALSE; // il ciclo di gioco deve continuare
};

void GLWVideo::muoviCurSu()
{
	if (Mat_y<8)
	{						
		if (!ObjSectCur.selezionato) ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=FALSE;
		Mat_y++;
		if ((scac[Mat_x][Mat_y]==-1)||(scac[Mat_x][Mat_y]>15))
			ObjSectCur.visible = true; // ma non  selezionato // -->  solo per capire dov' il cursore
		else if (ObjSectCur.selezionato==FALSE) ObjSectCur.visible = false;
		if (ObjSectCur.visible)
		{												
			ObjSectCur.x=(ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectCur.z=(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			/* Calcolo la nuova mossa per controllare che sia effettuabile */
				tmpMossa=mossa;
				tmpMossa*=100;
				tmpMossa += Mat_y + (Mat_x * 10);
		}
		else
		{					
			CurZ =(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=TRUE;
		}
	}
};

void GLWVideo::muoviCurGiu()
{
	if (Mat_y>1)
	{						
		if (!ObjSectCur.selezionato) ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=FALSE;
		Mat_y--;
		if ((scac[Mat_x][Mat_y]==-1)||(scac[Mat_x][Mat_y]>15))
			ObjSectCur.visible = true; // ma non  selezionato // -->  solo per capire dov' il cursore					
		else if (ObjSectCur.selezionato==FALSE) ObjSectCur.visible = false;
		if (ObjSectCur.visible)
		{							
			ObjSectCur.x=(ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectCur.z=(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			/* Calcolo la nuova mossa per controllare che sia effettuabile */
				tmpMossa=mossa;
				tmpMossa*=100;
				tmpMossa += Mat_y + (Mat_x * 10);
		}
		else
		{			
			CurZ = (ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=TRUE;
		}
	}
};

void GLWVideo::muoviCurSin()
{
	if (Mat_x>1)
	{					
		if (!ObjSectCur.selezionato) ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=FALSE;
		Mat_x--;
		if ((scac[Mat_x][Mat_y]==-1)||(scac[Mat_x][Mat_y]>15))
			ObjSectCur.visible = true; // ma non  selezionato // -->  solo per capire dov' il cursore													
		else if (ObjSectCur.selezionato==FALSE) ObjSectCur.visible = false;
		if (ObjSectCur.visible)
		{						
			ObjSectCur.x=(ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;				
			ObjSectCur.z=(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			/* Calcolo la nuova mossa per controllare che sia effettuabile */
				tmpMossa=mossa;
				tmpMossa*=100;
				tmpMossa += Mat_y + (Mat_x * 10);
		}
		else
		{
			CurX = (ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=TRUE;
		}
	}
};

void GLWVideo::muoviCurDes()
{
	if (Mat_x<8)
	{						
		if (!ObjSectCur.selezionato) ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=FALSE;
		Mat_x++;					
		if ((scac[Mat_x][Mat_y]==-1)||(scac[Mat_x][Mat_y]>15))
			ObjSectCur.visible = true; // ma non  selezionato // -->  solo per capire dov' il cursore									
		else if (ObjSectCur.selezionato==FALSE) ObjSectCur.visible = false;
		if (ObjSectCur.visible)
		{									
			ObjSectCur.x=(ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectCur.z=(ICurZ + QUAD_W*(Mat_y-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			/* Calcolo la nuova mossa per controllare che sia effettuabile */
				tmpMossa=mossa;
				tmpMossa*=100;
				tmpMossa += Mat_y + (Mat_x * 10);
		}
		else
		{				
			CurX = (ICurX - QUAD_W*(Mat_x-1))/RIMPICCIOLISCO_IL_MONDO_DI;
			ObjSectScacchi[scac[Mat_x][Mat_y]].selezionato=TRUE;
		}
	}
};

int GLWVideo::muovi_pezzo(unsigned int m) // restituisce 1 se la mossa  conclusa, 0 se  in corso
{
	int da_x  = ((m%10000)-(m%1000))/1000;
	int da_y  = ((m%1000) -(m%100))/100;
	int Mat_x = ((m%100)-(m%10))/10;
	int Mat_y = (m%10);

	short int iniz=scac[da_x][da_y];  
	short int fin= scac[Mat_x][Mat_y];

	/* imposto il cursore nella posizione della mossa del computer */
		ObjSectCur.x=(ICurX-(QUAD_W*(Mat_x-1)))/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSectCur.z=(ICurZ+(QUAD_W*(Mat_y-1)))/RIMPICCIOLISCO_IL_MONDO_DI;

	ObjSectScacchi[iniz].x -= (ObjSectScacchi[iniz].x-ObjSectCur.x)/25;
	ObjSectScacchi[iniz].z -= (ObjSectScacchi[iniz].z-ObjSectCur.z)/25;
	
	if (fin>=0)
	{
	//	ObjSectScacchi[fin].y += 0.1f/RIMPICCIOLISCO_IL_MONDO_DI;
		ObjSectScacchi[fin].esplosione+=0.1f - ObjSectScacchi[fin].esplosione/500;
		sto_mangiando=true;
	}	

	if ( ((fabs(ObjSectScacchi[iniz].x-ObjSectCur.x)<0.1f/RIMPICCIOLISCO_IL_MONDO_DI)&&
		 (fabs(ObjSectScacchi[iniz].z-ObjSectCur.z)<0.1f/RIMPICCIOLISCO_IL_MONDO_DI)) )
		return 1;
	return 0;
}

void GLWVideo::controllaOrientamento()
{
	/* controllo l'angolo della visuale per capire qual' il punto di vista interessato: bianchi o neri */
		int ang=yrot;
		while (ang>360) ang-=360; // porto l'angolo su scala calcolabile   *** poi sar sempre su scala calcolabile ********************* ******************
		while (ang<0)   ang+=360;
		if ((ang>135)&&(ang<225)) DirezioneComandi=1;
		else if ((ang>45)&&(ang<135)) DirezioneComandi=4;
		else if ((ang>225)&&(ang<315)) DirezioneComandi=3;
		else DirezioneComandi=2;
}

void GLWVideo::SetImmagineAvversario(char *s)
{
	char *Norm, *Attacca, *Subisce;

	if (s==NULL)   // se l'avversario non ha un'immagine
	{
		Norm="data/avversari/null.bmp";
		Attacca="data/avversari/null.bmp";
		Subisce="data/avversari/null.bmp";
	}
	else  // preparo le stringhe contenenti il nome dei file
	{
		Norm = new char[64];
		Attacca = new char[64];
		Subisce = new char[64];
		strcpy(Norm,    "data/avversari/");
		strcpy(Attacca, "data/avversari/");
		strcpy(Subisce, "data/avversari/");
		strcat(Norm,    s);
		strcat(Attacca, s);
		strcat(Subisce, s);
		strcat(Norm,    "/");
		strcat(Attacca, "/");
		strcat(Subisce, "/");
		strcat(Norm,    s);
		strcat(Attacca, s);
		strcat(Subisce, s);
		strcat(Norm,    "_Normale.bmp");
		strcat(Attacca, "_Attacca.bmp");
		strcat(Subisce, "_Subisce.bmp");
	}
	
	/* Libero i puntatori dalle immagini precedentemente caricate */
		free(imgAvvNorm);
		free(imgAvvAttacca);
		free(imgAvvSubisce);

	/* Carico le immagini */
 		imgAvvNorm = LoadBitmapFile(Norm, &imgAvvNormHead);
		imgAvvAttacca = LoadBitmapFile(Attacca, &imgAvvAttaccaHead);
		imgAvvSubisce = LoadBitmapFile(Subisce, &imgAvvSubisceHead);	
}

void GLWVideo::SetImmagineScenario(char *s)
{
	char *img;

	if (s==NULL)   // se l'avversario non ha un'immagine
	{
		img="data/avversari/null.bmp";  // cos risparmio spazio		
	}
	else  // preparo le stringhe contenenti il nome dei file
	{
		int n=strlen(s)-1;
		img = new char[64];		
		strcpy(img, s);	
		img[n-2]='b';
		img[n-1]='m';
		img[n]  ='p';
	}
	
	/* Libero i puntatori dalle immagini precedentemente caricate */
		free(imgStage);	

	/* Carico le immagini */
 		imgStage = LoadBitmapFile(img, &imgStageHead);		
}

float GLWVideo::max_vertex(float *v, int n)
{
	float max=v[0];

	for (int i=1; i<n; i++)
		if (v[i]>max) max=v[i];

	return max;
}

float GLWVideo::min_vertex(float *v, int n)
{
	float min=v[0];

	for (int i=1; i<n; i++)
		if (v[i]<min) min=v[i];

	return min;
}


/* testo */
	GLvoid GLWVideo::BuildFont(GLvoid)								// Costruisce il nostro Font Bitmap 
	{
		BuildSingleFont(&chat, 16, &fontChat);
		BuildSingleFont(&base, 32, &fontBase);
	}

	GLvoid GLWVideo::BuildSingleFont(GLuint *baseFont, int size, HFONT *oldFont)
	{
		HFONT	font;										// Windows Font ID
		HFONT	*oldfont;									// Usato per tenere il vecchio font
		oldfont=oldFont;

		*baseFont = glGenLists(96);								// Spazio per 96 caratteri

		font = CreateFont(	size,							// Altezza del Font
							0,								// Larghezza del Font
							0,								// Angolo di Scappamento
							0,								// Angolo d'Orientamento
							FW_NORMAL,						// Peso del Font 
							FALSE,							// Corsivo
							FALSE,							// Sottolineato
							FALSE,							// Barrato
							ANSI_CHARSET,					// Identificatore del Set di Caratteri
							OUT_TT_PRECIS,					// Precisione di Output 
							CLIP_DEFAULT_PRECIS,			// Precisione di Clipping 
							ANTIALIASED_QUALITY,			// Qualit di Output 
							FF_DONTCARE|DEFAULT_PITCH,		// Famiglia e Passo
							"Comic Sans MS");						// Nome del Font 

		*oldfont = (HFONT)SelectObject(hDC, font);          // Seleziona il Font desiderato
		wglUseFontBitmaps(hDC, 32, 96, *baseFont);			// Costruisce 96 caratteri partendo dal carattere 32
		SelectObject(hDC, *oldfont);						// Seleziona il Font desiderato
		DeleteObject(font);									// Cancella il Font
	}

	GLvoid GLWVideo::KillFont(GLvoid)									// Cancella le Font List
	{
		glDeleteLists(base, 96);							// Cancella tutti i 96 caratteri
		glDeleteLists(chat, 96);

		/* cancella la lista di comandi */
			KillMenuCom();
	}

	GLvoid GLWVideo::KillMenuCom(GLvoid)
	{
		//char *s;
		for (selCom = menuCom; selCom!=NULL; menuCom = selCom)  // elimino la lista di comandi men
		{
			selCom = selCom->next;			
			//s=menuCom->testo;
			delete menuCom->testo;
			delete menuCom;
		}

		selCom=NULL;
		menuCom=NULL;
	}

	GLvoid GLWVideo::glPrint(char *fmt, GLuint *base)		// Funzione GL "Print" personalizzata // per ora uso i Bitmap Fonts
	{
	//	char		text[64];								// Contiene la nostra stringa
//		SelectObject(hDC, *Font);

		va_list		ap;										// Puntatore alla lista degli argomenti

		if (fmt == NULL)									// Se non c' testo
			return;											// Ritorna senza fare niente
		
		glPushAttrib(GL_LIST_BIT);							// Spinge i Bit della Display List 
			glListBase(*base - 32);								// Setta la base dei caratteri a 32
			glCallLists(strlen(fmt), GL_UNSIGNED_BYTE, fmt);	// Disegna il testo con le Display List 
		glPopAttrib();										// Rimette i settaggi a posto
	}

	GLvoid GLWVideo::scrivi(int aggiungi, int ID, bool parametri, const char *fmt, ...)
	{	
		if (aggiungi==0) KillMenuCom();   // svuoto la lista se richiesto

		/* aggiungo il comando interessato in testa alla lista */
			char *c;
			MENU_COM *tmp;
			tmp = new MENU_COM;
			tmp->ID=ID;				

			c = new char[128];
			if (parametri)  // se ci sono parametri li converto e li inserisco nella stringa
			{				
				va_list		ap;										// Puntatore alla lista degli argomenti
				if (fmt == NULL)									// Se non c' testo
					return;											// Ritorna senza fare niente
				
				va_start(ap, fmt);									// Analizza la stringa per le variabili
					vsprintf(c, fmt, ap);						// E converte i simboli in numeri
				va_end(ap);											// Il risultato viene messo in "Text"				
			}
			else
			{
				strcpy(c, fmt);
			}

			tmp->testo=c;
			tmp->next=menuCom;
			tmp->prec=NULL;
			if (menuCom!=NULL) menuCom->prec=tmp;
			menuCom=tmp;
				
		selCom=menuCom;  // il primo elemento (l'ultimo inserito) deve essere selezionato
	}

	GLvoid GLWVideo::modifica_comando(int ID, bool parametri, const char *fmt, ...)
	{
		MENU_COM *tmp;
		for(tmp=menuCom; (tmp!=NULL)&&(tmp->ID!=ID); tmp=tmp->next)
			;
		if (tmp!=NULL)
		{			
			char *ce;
			ce = new char[128];			
			if (parametri)  // se ci sono parametri li converto e li inserisco nella stringa
			{				
				va_list		ap;										// Puntatore alla lista degli argomenti
				if (fmt == NULL)									// Se non c' testo
					return;											// Ritorna senza fare niente
				
				va_start(ap, fmt);									// Analizza la stringa per le variabili
					vsprintf(ce, fmt, ap);						// E converte i simboli in numeri
				va_end(ap);											// Il risultato viene messo in "Text"				
			}
			else
			{
				strcpy(ce, fmt);
			}			
			strcpy(tmp->testo, ce);			
			delete ce;
		}		
	}

	/* Rispetto all'ordine della lista next e prec sono invertiti, perch utilizzo l'inserimento in testa per facilit e rapidit, dunque gli elementi sono ordinati inversamente a come vengono visualizzati */
	GLvoid GLWVideo::SelTextPrec(GLvoid)
	{
		if (selCom!=NULL)
			if (selCom->next!=NULL)
				selCom=selCom->next;
	}

	GLvoid GLWVideo::SelTextNext(GLvoid)
	{
		if (selCom!=NULL)
			if (selCom->prec!=NULL)
				selCom=selCom->prec;
	}

	int GLWVideo::GetSelTextIndex(GLvoid)
	{
		if (selCom!=NULL) return selCom->ID;
		else return 0;
	}

	/* Funzioni riguardanti la chat */
	GLvoid GLWVideo::SetChatSuoTesto(char *s)
	{
		if (strlen(s)<=MAX_LENGTH_CHAT_BUFFER)		
			strcpy(chatSuoTesto, s);		
	}
	

	void GLWVideo::gestioneMossaTmp(int mossaposs)
	{		
		if (mossaposs==0) // mossa non accettabile
			ObjSectCur.cursore=1;		
		else                          // mossa accettabile		
			ObjSectCur.cursore=2;
	}
