// GLWVideo.h: interface for the GLWVideo class.
// by Oligoatria
//////////////////////////////////////////////////////////////////////

#ifndef GLWVIDEO_H
#define GLWVIDEO_H

#define MAX_LENGTH_CHAT_BUFFER 64
#define RIMPICCIOLISCO_IL_MONDO_DI 4

struct SECTOR_OBJ;

struct MENU_COM         // struttura mirata alla creazione di una lista doppia (circolare o meno, a seconda del tipo di men)
{                       // contenente tutti i comandi di un men
	unsigned int ID;         //  necessario per poter comunicare di quale comando si tratta
	char *testo;             // ci che l'utente visualizza
	//bool parametri;
	
	MENU_COM *next, *prec;    // elementi precedente e successivo
};

class GLWVideo  
{

public:
	GLWVideo();
	virtual ~GLWVideo();
	
public:
	GLWVideo(float ral, int x, int y, int bits);
	void InitWorldVar(GLvoid);
	BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);
	int InitOrDestroy(char *world, unsigned int luci, bool scacchi); // richiama InitGL
	int InitWorld(char *s);  // ritorna TRUE se tutte le operazioni sono state svolte correttamente	
	void AddToWorld(char *filename, float x, float y, float z, int flip, int ID, BOOL blend); // permette di aggiungere al mondo degli altri oggetti grafici nella posizione voluta
	SECTOR_OBJ *GetObjectByID(int ID);
	void MoveObjectID(int ID, GLfloat x, GLfloat y, GLfloat z);
	void ExplodeObjectID(int ID, GLfloat plus_explode);
	void ExplodeWorld(GLfloat plus_explode);
	void RotateObjectID(int ID, GLfloat angolo, char asse); // per ruotare un oggetto della lista ObjSectList
	void DelFromWorld(int ID); // elimina l'oggetto desiderato
	void DestroyWorld(GLvoid);
	int Disegna(char *com);       // ritorna TRUE se il gioco deve terminare
	GLvoid ReSizeGLScene(GLsizei width, GLsizei height);		// Ridimensiona e Inizializza la Finestra GL 
	GLvoid KillGLWindow(GLvoid);								// Distrugge in modo corretto la finestra

	char *Wnd_Name;
		
		float max_vertex(float *v, int n);
		float min_vertex(float *v, int n);

	/* variabili riguardanti i movimenti del personaggio */
		int muovi_pezzo(unsigned int m); // restituisce 1 se la mossa  conclusa, 0 se  in corso
		int avanti, giu;		

	/* Mosse e cursore */
		void controllaOrientamento();   // controlla l'angolo di orientamento, necessario a coordinare i movimenti del cursore
		void gestioneMossaTmp(int mossaposs);
		int Muovi(unsigned int m);   // esegue una mossa aggiornando grafica e matrice scac // restituisce 1 se il re  stato mangiato
		void muoviCurSu();	
		void muoviCurGiu();
		void muoviCurSin();
		void muoviCurDes();
		
public:	
	bool	fullscreen;			// Flag di Schermo Intero settato alla modalit Schermo Intero di default
	bool	blend;				// Blending ON/OFF
	
	float Rallentamento;  //***
	int Screen_X;
	int Screen_Y;
	int Screen_BITS;

	int texture_vittoria; // indice della texture di vittoria

	bool sto_mangiando;

	/* testo */
		GLuint	base;				// Display List di base per il set di caratteri
		GLuint	chat;				// Display List di base per il set di caratteri per la mini chat
		GLfloat	cnt1;				// 1 contatore usato per muovere il Testo e per il Colore
		GLfloat	cnt2;				// 2 contatore usato per muovere il Testo e per il Colore

private:
		GLvoid BuildFont(GLvoid);             // Costruisce le Font Bitmap  // base e chat
		GLvoid BuildSingleFont(GLuint *baseFont, int size, HFONT *oldFont); // Costruisce 1 font Bitmap
		GLvoid glPrint(char *fmt, GLuint *base); // Funzione GL "Print" personalizzata		
		char chatSuoTesto[MAX_LENGTH_CHAT_BUFFER];		
		MENU_COM *menuCom;          // lista di comandi men
		MENU_COM *selCom;           // puntatore al comando selezionato

public:
		GLvoid scrivi(int aggiungi, int ID, bool parametri, const char *fmt, ...);  // aggiunge alla lista un comando di testo *fmt, id ID, se aggiungi  == 1, se  == 0 cancella la lista e inserisce il comando come primo elemento
		GLvoid modifica_comando(int ID, bool parametri, const char *fmt, ...); // modifica il testo di un comando
		GLvoid KillMenuCom (GLvoid);          // Distrugge la lista di comandi men -  richiamata da KillFont()
		GLvoid KillFont(GLvoid);	          // Cancella le Font List e l'elenco dei comandi		
		GLvoid SelTextNext(GLvoid);                   // seleziona l'elemento successivo della lista
		GLvoid SelTextPrec(GLvoid);                   // seleziona l'elemento precedente della lista
		int    GetSelTextIndex(GLvoid);               // restituisce l'ID del comando selezionato
		GLvoid SetChatSuoTesto(char *s);
		char chatMioTesto[MAX_LENGTH_CHAT_BUFFER];         // i buffer di comunicazione tramite chat
		int chatMioTestoLength;
		
		void   SetImmagineAvversario(char *s);        // imposto le stringhe con i nomi dei file dell'avversario		
		void SetImmagineScenario(char *s);
		int mostraAvversario; // 0-no, 1-norm, 2-attacca, 3-subisce		
		bool mostraImgStage;
		bool scriviChat;

		bool testoActive;           // il men  attivo, ovvero deve essere visualizzato?
		HFONT fontBase, fontChat;

		bool riconoscimenti;


private:
	void readstr(FILE *f,char *string);
	AUX_RGBImageRec *LoadBMP(char *Filename);	// Carica un'immagine Bitmap 
	int LoadGLTextures();
	int AddTexture(char *nome_file);
	GLvoid InitTextureVittoria(GLvoid); // salva in texture_vittoria l'indice della texture in contatto con la quale si vince
	void SetupWorld();      // carica il mondo --> formato triangoloXtriangolo
	void SetupWorld_nff(const char *SrcFile, SECTOR_OBJ *ObjSect, float x, float y, float z, int flip, BOOL selezionabile=TRUE, BOOL visible=TRUE, BOOL blend=FALSE);  // carica il mondo --> formato nff	
	void DestroyWorld_nff(SECTOR_OBJ *ObjSect);  // distrugge e dealloca il settore
	int InitGL(char *world, unsigned int luci, bool scacchi);										// Tutti i settaggi per OpenGL vengono fatti qui
	int Init_Modelli_Scacchi();         // Carica nelle relative strutture i modelli dei pezzi da gioco
	int DrawGLScene(GLvoid);
	int DrawGLScene_nff(SECTOR_OBJ *ObjSect);
	int DrawAll();   // utilizzando la funzione DrawGLScene_nff disegna tutto il necessario	
	// Qui  dove farete tutti i disegni		
	

	bool	bp;					// Il tasto B  premuto?
	bool	lp;					// Il tasto L  premuto?
public:
	bool	fp, fW, fA, fS, fD, fSPACE, fESCAPE;					// Il tasto F  premuto? // fps
	int tasto_premuto; // 0==nessuno
private:
	bool is_scacchi;
	unsigned int  is_illuminato;  // 0==no - 1==si - 2==si+colorMaterial

	/* immagini */
		unsigned char *LoadBitmapFile(char *filename, BITMAPINFOHEADER *bitmapInfoHeader);
		BITMAPINFOHEADER	menuBMPInfoHeader;	// bitmap info header
		unsigned char*		menuBMPData;		// the bitmap data
		BITMAPINFOHEADER	imgAvvNormHead;
		unsigned char*		imgAvvNorm;
		BITMAPINFOHEADER	imgAvvAttaccaHead;
		unsigned char*		imgAvvAttacca;
		BITMAPINFOHEADER	imgAvvSubisceHead;
		unsigned char*		imgAvvSubisce;
		BITMAPINFOHEADER	imgStageHead;
		unsigned char*		imgStage;
};


#endif /* GLWVIDEO_H */
