// GameVar.h: interface for the GameVar class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GAMEVAR_H
#define GAMEVAR_H


	/* prototipo metodi e variabili globali */
	//	extern void FPS(); // Calcolo le fps
	//	extern int GetFPS (void);									// Returns The FPS If Called Every Frame

		extern HWND			hWnd;		// Handle alla Finestra 

	/* variabili di stato */
		int STATE;
			#define SMENU 0           // men di pausa
			#define SWAIT_ME 1        // io devo scegliere la mossa
			#define SWAIT_COMPUTER 2  // il computer deve muovere
			#define SMOVE 3           // stato di animazione (tra una mossa e l'altra)
			#define SWIN  4           // vittoria
			#define SWAIT_NETWORK 5   // aspetto la mossa del mio avversario (partita in rete)
			#define SWAIT_COMPUTER_THINK 6  // il computer sta pensando

	/* Movimento del soggetto */
		//float	heading;
		float	xpos;
		float	zpos;
		float   ypos;
		
		GLfloat walkbias;
		GLfloat walkbiasangle;
		GLfloat	z;				    // Profondit nello Schermo

	/* Visuale (camera) */
		void Mouse_move();		

	/* variabili di gioco */		
		int vittoria=0;  // 0 niente, -1 sconfitta, 1 vittoria (l'uscita  considerata come sconfitta */
//		int vel_gra;

	/* fps */
		int fps;        // devono essere 60	
		int FPS_DELTA=2;// = 0.1s  // l'intervallo di tolleranza per la fps
		int FPS_VOLUTI=60;
		int FPS_LIMITE_MODIFICA=0;	

	/* Suoni */
		int TEMPO_EFFETTO1;
	
	/* posizione del cursore */
		int tmpMossa, mossa, mossaComputer;    // calcolo della mossa - in base al suo valore so se  stata 
					   // decisa una muova operazione
		float ICurX, ICurZ; // posizione di partenza
		float CurX, CurZ;
		float QUAD_W;
		int Mat_x, Mat_y;          // indici della griglia-scacchiera
		int da_x, da_y;                // muovo il pezzo in posizione da_x, da_y
		
	/* connessione di rete */
		SOCKET serv, cli;  // li tengo separati fino alla risoluzione del bug di fine ricezione, riguardante il server
		SOCKET sockChatRiceve, sockChatInvia;
		cNetProtocol cSock;

		unsigned int iIP[4] = { 127, 0, 0, 1 };
 
		/* Gestione dei thread */
			cThreadManager ThreadManager;

	/* Opzioni */		
		//extern int ral;
		extern int SCREEN_X;
		extern int SCREEN_Y;
		extern int SCREEN_BITS;
		//extern bool screen_dinamico;
		char *Stage;
		unsigned int illuminato=2;
		int Avversario;
		unsigned int Avversario_livello;
		bool musiche=true, effetti_sonori=true;

		extern GLfloat	yrot;
		extern float	heading;
		extern GLfloat  lookupdown;

void InitGameVar()
{		
	/* variabili di gioco */	
	//	int vel_gra = 6;
	
	/* fps */
	/*	 FPS_DELTA = 2;	// = 0.1s  // l'intervallo di tolleranza per la fps
		 FPS_VOLUTI = 60;
		 FPS_LIMITE_MODIFICA = 0;	*/

	/* Suoni */
		TEMPO_EFFETTO1=200;
   
	/* posizione del cursore */
		mossa=0;
		ICurX=2.4f;
		ICurZ=-1.4f;
		CurX=ICurX;
		CurZ=ICurZ;
		QUAD_W=1.4f;
		Mat_x=1;
		Mat_y=1;
}

char *IntToStr(int nValue) {                          // *** funzione di ch!cus ***
    char *szValue = (char*)calloc(3, sizeof(char));
    sprintf(szValue,"%d\0", nValue);
    return szValue;
}



#endif /* GAMEVAR_H */
