// Questo modulo  lo sviluppo di quello scritto da me (Oligoatria) e da
// Niccolo' (Shutdown) Ciardo per il progetto NETSAM

#ifndef THREADMANAGER_H
#define THREADMANAGER_H

/* Il massimo dei thread da gestire */
#define TD_MAX          3 /* thread da gestire al massimo */

/* Stato del thread */
#define TDS_FREE        0 /* thread non creato */
#define TDS_RUN         1 /* thread in esecuzione */
#define TDS_SUSPEND     2 /* thread sospeso */
#define TDS_DELETE      3 /* thread eliminato */

/* ID di alcuni thread */
#define THREAD_RICEZIONE_MOSSA 1
#define THREAD_RICEZIONE_CHAT 2

/* Struttura di un thread */
struct Thread {
    HANDLE handle; /* handle per il thread */
    unsigned int id;      /* id del thread */
    int state;     /* stato del thread */
};

class cThreadManager
{
	private:		
		struct Thread thread[TD_MAX]; /* array dei thread da gestire */

	public:
		unsigned int newThrd(unsigned int idThrd, void *pFunc, LPVOID lpParam); /* crea e avvia nuovo thread */
		unsigned int pauseThrd(int idThrd);  /* sospende o riprende thread */
		void closeThrd(unsigned int idThrd); /* elimina un thread */
		void closeStopThisThrd(unsigned int idThrd); /* chiude il thread che la richiama */		
		unsigned int freeThrds(void);        /* libera memoria non pi utilizzata da thread chiusi */
};

#endif /* THREADMANAGER_H */
