#include <windows.h>		// File d'Intestazione per Windows
#include <stdio.h>			// File d'Intestazione per Standard Input/Output

extern HWND		hWnd;		// Handle alla Finestra 

int GetFPS (void)							// Returns The FPS If Called Every Frame
{
	// Windows Timer Frequency And Previous Time
	static LARGE_INTEGER TimerFrequency,LastTime;

	static int FPS=60;								// Frames Per Second

	// Get The Windows Timer Frequency
	if (!TimerFrequency.QuadPart) QueryPerformanceFrequency(&TimerFrequency);
		else										// Calculate The Framerate
	{
		LARGE_INTEGER Time;							// The Current Time

		QueryPerformanceCounter(&Time);				// Get The Current Time

		if (LastTime.QuadPart!=0 && (Time.QuadPart-LastTime.QuadPart)!=0)
		{
			// Calculate the FPS
			int NewFPS=((int)(TimerFrequency.QuadPart/(Time.QuadPart-LastTime.QuadPart)));

			if (!FPS) FPS=NewFPS;
				else
			{
				if (FPS>NewFPS) FPS--;				// Only Change 1 FPS At A Time
					else if (FPS<NewFPS) FPS++;
			}
		}

		LastTime.QuadPart=Time.QuadPart;			// Remember The Current Time
	}

	// Make Sure The FPS Is At Least 1 To Prevent Devide By 0
	if (FPS<1) FPS=1;

	return FPS;
}

void FPS()					// Calcolo le fps
{
	static float fps           = 0.0f;						
    static float previousTime  = 0.0f;	
	static char  strFPS[20]    = {0};
	
	float currentTime = (GetTickCount() * 0.001f);				

    ++fps;	

    if( currentTime - previousTime > 1.0f )
    {
	    previousTime = currentTime;
		sprintf(strFPS, "FPS: %d", int(/*fps*/GetFPS()));
	//	SetWindowText(hWnd, strFPS);
        fps = 0.0f;
    }
}
