#include <winsock2.h>
#include <windows.h>		// File d'Intestazione per Windows
#include <stdio.h>			// File d'Intestazione per Standard Input/Output (FILE)
#include <gl\glu.h>			// File d'Intestazione per la libreria GLu32 
#include <gl\glaux.h>		// File d'Intestazione per la libreria Glaux 

#include "GLWVideo.h"
#include "audiosystem.h"

#include "Scacchi.h"

#include "ThreadManager.h"
#include "netProtocol.h"

#include "GameVar.h"
#include "Livello.h"

#define NETWORK_PORT 100
#define NETWORK_PORT_CHAT_INVIA 101
#define NETWORK_PORT_CHAT_RICEVE 103

/* Funzioni di gioco */
	void ComputerPensa(RandScacchi *cr)
	{
		cr->main_scacchi();
	}


void Sigla1(GLWVideo *Screen, CAudioSystem **audioSystem)
{
	/* sistema sonoro */ // quando avr a disposizione + musiche avr senso spostare il tutto nelle funzioni di livello.cpp
		CAudio *sndMusicaSigla, *sndEsplosione;
		
		sndMusicaSigla = audioSystem[0]->Create("data/suoni/Intro_OliSoft10.wav", false);
		sndEsplosione = audioSystem[2]->Create("data/suoni/Esplosione.wav", false);

		audioSystem[0]->Play(sndMusicaSigla, DMUS_SEG_REPEAT_INFINITE);

	/* Inizializzo il mondo */
		SECTOR_OBJ *oli, *soft;

		Screen->InitWorldVar();
		Screen->InitOrDestroy(STAGE_TAVOLINO, FALSE, TRUE);
		Screen->AddToWorld("data/Oligoatria.nff", 19.0f, 7.0f, 12.0f, false, OLI, false);
		//Screen->AddToWorld("data/goatria.nff", 5.0f, 5.0f, 0.0f, false, GOATRIA, false);
		Screen->AddToWorld("data/Soft.nff", -20.0f, 5.0f, 12.0f, false, SOFT, false);
		oli=Screen->GetObjectByID(OLI);
		soft=Screen->GetObjectByID(SOFT);
		int oli_x=52, oli_z=70;
		int soft_x=120, soft_z=80;
		int n=0, m=0;

	/* Variabili del ciclo di gioco */
		MSG		msg;									// Struttura Windows Message 
		int	done=0;									// Variabile int per uscire dal ciclo
		char com;
		bool inizia_Oligoatria=false;
		
	/* fps */
		int count_fps=0;
		GLfloat deg;				// Facing Degree
		int i, msSleep=90000; // attesa ad ogni ciclo	
		long tempo=timeGetTime(), ttempo; // restituisce il time di sistema (windows) in millisecondi		
		
	/* file relativo alla sigla */
		FILE *fSrc;
		fSrc = fopen("data/sigla/sigla_TheLastChess.oli", "rt");  // apro il file in lettura

		char buffer[256];
		bool continua=false;
		int lol=0;
			
		if (fgets( buffer, 255, fSrc)==NULL) return;			
		xpos=(strtod(buffer, NULL)/100)/RIMPICCIOLISCO_IL_MONDO_DI;
		if (fgets( buffer, 255, fSrc)==NULL) return;			
		ypos=(strtod(buffer, NULL)/100)/RIMPICCIOLISCO_IL_MONDO_DI;
		if (fgets( buffer, 255, fSrc)==NULL) return;			
		zpos=(strtod(buffer, NULL)/100)/RIMPICCIOLISCO_IL_MONDO_DI;
		if (fgets( buffer, 255, fSrc)==NULL) return;			
		yrot=strtod(buffer, NULL)/100;
		if (fgets( buffer, 255, fSrc)==NULL) return;			
		lookupdown=strtod(buffer, NULL)/100;

	/* Ciclo di gioco */
		while(!done)									// Ciclo che si ripete finch done=FALSE
		{	
			if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// C' un messaggio in attesa?
			{
				if (msg.message==WM_QUIT)				// Abbiamo ricevuto un messaggio di chiusura?
				{
					done=TRUE;							// Se s, done=TRUE
				}
				else									// Se no, gestisci i messaggi Window 
				{
					TranslateMessage(&msg);				// Traduce il Messaggio
					DispatchMessage(&msg);				// Invia il Messaggio
				}
			}
			else
			{
				/*Gestione fps */			
					count_fps++;
					fps=GetFPS();					// Frames Per Second
					deg+=0.2f/(fps/60.0f);			// Spin The Sky
					if (count_fps>(fps/120))
					{
					//	Mouse_move();			
						count_fps=0;					
					}
					
					FPS();

				if (inizia_Oligoatria)
				{
				//	Screen->InitWorldVar();
											
					Screen->ExplodeWorld(0.5f);
					if (oli_x)
					{
						if (n++<oli_x) 
						{
							Screen->MoveObjectID(OLI, -0.10f, 0, 0);
							Screen->MoveObjectID(SOFT, +0.10f, 0, 0);
						}
						else
						{
							n=0;
							oli_x=0;
						}
					}
					else
					{
						if ((keys[VK_ESCAPE])||(keys[VK_SPACE])||(keys[VK_RETURN])) done=2;

						if (oli_z)
						{
							if (n++<oli_z) Screen->RotateObjectID(SOFT, (m++)*(m++), 'y');
							else
							{
								n=0;
								oli_z=0;
								audioSystem[2]->Play(sndEsplosione, 0);
							}
						}
						else
						{						
							Screen->ExplodeObjectID(SOFT, 1.0f);
							if (soft_x)
							{
								if (n++<soft_x) Screen->RotateObjectID(OLI, ((m++)*(m++))/100, 'x');
								else
								{
									n=0;
									soft_x=0;
									audioSystem[2]->Play(sndEsplosione, 0);
								}
							}
							else
							if (soft_z)
							{
								if (n++<soft_z)Screen->ExplodeObjectID(OLI, 1.0f);
								else
								{
									n=0;
									soft_z=0;
								}
							}
							else done=2;
						}
					}

					Screen->Disegna(&com);
				}
				else
				{					
					lol=0;
					continua=true;
					if (fgets(buffer, 255, fSrc)==NULL)	inizia_Oligoatria=true;

					while (continua)
					{
						continua=false;
						com=buffer[lol++];
					
						if (com==VK_NUMPAD8)						// E' stato premuto F1?
						{						
							Screen->avanti = 100/RIMPICCIOLISCO_IL_MONDO_DI;
							continua=true;
						}
						

						if (com==VK_NUMPAD2)						// E' stato premuto F1?
						{
							Screen->avanti = -100/RIMPICCIOLISCO_IL_MONDO_DI;
							continua=true;
						}

						if (com==VK_NUMPAD4)						// E' stato premuto F1?
						{
						//	heading += (100.0f/Screen->Rallentamento);
						//	yrot = heading;
							continua=true;
						}

						if (com==VK_NUMPAD6)						// E' stato premuto F1?
						{
						//	heading -= (100.0f/Screen->Rallentamento);
					//		yrot = heading;
							continua=true;
						}

						if (com==VK_NUMPAD7)						// E' stato premuto F1?
						{
							ypos+=0.1f/RIMPICCIOLISCO_IL_MONDO_DI;
							continua=true;
						}

						if (com==VK_NUMPAD1)						// E' stato premuto F1?
						{
							ypos-=0.1f/RIMPICCIOLISCO_IL_MONDO_DI;
							continua=true;
						}
					}
					if (fgets( buffer, 255, fSrc)==NULL) inizia_Oligoatria=true;			
						
						yrot=strtod(buffer, NULL)/100;
					if (fgets( buffer, 255, fSrc)==NULL) inizia_Oligoatria=true;		
					
					lookupdown=strtod(buffer, NULL)/100;

					heading=yrot;

					Screen->Disegna(&com);								

					for (i=0; i<msSleep; i++) 
						ttempo=strcmp("sss","ssssssss");

					if ((keys[VK_ESCAPE])||(keys[VK_SPACE])||(keys[VK_RETURN]))	inizia_Oligoatria=true;
					
					if (inizia_Oligoatria)
					{
						ypos=7.0f/RIMPICCIOLISCO_IL_MONDO_DI;
						xpos=-5.0f/RIMPICCIOLISCO_IL_MONDO_DI;
						zpos=-8.0f/RIMPICCIOLISCO_IL_MONDO_DI;	
						yrot = 180.0f;	
						lookupdown=0;
					}
				}
			}			
		}
	
	audioSystem[0]->Stop(sndMusicaSigla);
	delete sndMusicaSigla;
	delete sndEsplosione;
	
	fclose(fSrc);
	Screen->DelFromWorld(OLI);
	Screen->DelFromWorld(SOFT);
	Screen->DestroyWorld();
}

int Menu(GLWVideo *Screen, CAudioSystem **audioSystem)
{		

	/* sistema audio */
		CAudio *sndCambia, *sndSelezione;
		
		sndCambia = audioSystem[1]->Create("data/suoni/MuoviSelezione.wav", false);
		sndSelezione = audioSystem[2]->Create("data/suoni/CambioSelezione.wav", false);
	

	/* Inizializzo le variabili di gioco */
		Stage=STAGE_TAVOLINO;   // evitiamo possibili bug
		Screen->InitWorldVar();
		
		Screen->SetImmagineAvversario(AVVERSARIO1);
		Avversario=1;           // di default ReDenzis
		Avversario_livello=AVVERSARIO_LIVELLO1;
		Screen->mostraAvversario=false;

	/* Inizializzo il mondo */			
		Screen->InitOrDestroy(STAGE_DESERTO, FALSE, FALSE);		
		Screen->AddToWorld("data/Title_1.nff", -5.0f, 5.0f, 0.0f, false, SCELTA1, true);
		Screen->AddToWorld("data/Title_2.nff", -5.0f, 5.0f, 0.0f, false, SCELTA2, false);

	/* Variabili del ciclo di gioco */			
		MSG		msg;									// Struttura Windows Message 
		int	done=0;								// Variabile int per uscire dal ciclo
		char com='<', com2='m';
		int menuAttuale=MENU_NULL;
		short int mosso;  // 0==no, 1==x+, 2==y+, -1==x-, -2=y-
		float tmp_rot=0.0f;
		short int scelta_x=0, scelta_y=1;  // scelta x: 1P - 2P - 2P NET - OPZIONI
		                                   // scelta y:   1 - RICONOSCIMENTI   
										   //             0 - scelta_x
										   //            -1 - ESCI
			
	/* fps */
		int i;
		long tempo=timeGetTime(), ttempo; // restituisce il time di sistema (windows) in millisecondi		
		long attesa;		
		int msSleep=90000; // attesa ad ogni ciclo		
		int modifica=0;    // variabile per attutire gli sbalzi di velocit
		int count_fps=0;
		GLfloat deg;				// Facing Degree
			
	/* Stato dei socket */
		in_connessione=false;

	/* Stato del cursore */
		ShowCursor(TRUE);	
			
	/* ciclo di gioco */
		while(!done)									// Ciclo che si ripete finch done=FALSE
		{	
			if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// C' un messaggio in attesa?
			{
				if (msg.message==WM_QUIT)				// Abbiamo ricevuto un messaggio di chiusura?
				{
					done=TRUE;							// Se s, done=TRUE
				}
				else									// Se no, gestisci i messaggi Window 
				{
					TranslateMessage(&msg);				// Traduce il Messaggio
					DispatchMessage(&msg);				// Invia il Messaggio
				}
			}
			else										// Se non ci sono messaggi
			{	
				/*Gestione fps */			
					count_fps++;
					fps=GetFPS();					// Frames Per Second
					deg+=0.2f/(fps/60.0f);			// Spin The Sky
					if (count_fps>(fps/120))
					{
						//Mouse_move();									
						count_fps=0;					
					}
					
					FPS();

				if (com=='<')
				{
					Screen->Disegna(&com);	 // disegna ed acquisisce un comando
					mosso = 0;

					/* Cambio selezione */
					if ((com=='w')&&(scelta_x<1)){
						tmp_rot=scelta_x;
						scelta_x++;
						mosso = 1;
					}else
					if ((com=='s')&&(scelta_x>-1)){
						tmp_rot=scelta_x;
						scelta_x--;
						mosso = -1;
					}else
					if ((com=='a')&&(scelta_x==0)){						
						if ((--scelta_y)<1) scelta_y=4;
						tmp_rot=scelta_y+1;
						mosso = -2;
					}else
					if ((com=='d')&&(scelta_x==0)){						
						if ((++scelta_y)>4) scelta_y=1;
						tmp_rot=scelta_y-1;
						mosso = 2;
					}else
					/* ho scelto */
					if (com==' '){
						if (scelta_x==1)       // Esci
						{
							audioSystem[2]->Play(sndSelezione, 0);
							done=-1;
						}
						else if (scelta_x==-1) // Riconoscimenti
						{
							audioSystem[2]->Play(sndSelezione, 0);
							
							MenuRiconoscimenti(Screen);
							
							//Screen->testoActive=true;
						
							com='r'; 
						}
						else if (scelta_y==1)  // 1P
						{
							audioSystem[2]->Play(sndSelezione, 0);
							done=1;
						}
						else if (scelta_y==2)  // Opzioni
						{
							audioSystem[2]->Play(sndSelezione, 0);
							
							MenuOpzioni(Screen);
							
							Screen->testoActive=true;
						
							com='m';
						}
						else if (scelta_y==3)  // 2P NET
						{		
							audioSystem[2]->Play(sndSelezione, 0);
							Menu2PNET(Screen);
							Screen->testoActive=true;
						
							com='m';
						}
						else if (scelta_y==4)  // 2P
						{
							audioSystem[2]->Play(sndSelezione, 0);
							done=2;
						}
					}
					else
						com='<';
				}
				else if (com=='c')   // men 2P NETWORK CLIENT
				{
					if (com2=='w')
					{
						audioSystem[1]->Play(sndCambia, 0);
						Screen->SelTextNext();
					}
					else if (com2=='s')
					{
						audioSystem[1]->Play(sndCambia, 0);
						Screen->SelTextPrec();
					}
					else if (com2=='d')    // imposta l'indirizzo IP del server interessato
					{
						if (Screen->GetSelTextIndex() == MENU_IP_0)
							Screen->modifica_comando(MENU_IP_0, true, "%i", ++iIP[0]);
						else if (Screen->GetSelTextIndex() == MENU_IP_1)
							Screen->modifica_comando(MENU_IP_1, true, "%i", ++iIP[1]);
						else if (Screen->GetSelTextIndex() == MENU_IP_2)
							Screen->modifica_comando(MENU_IP_2, true, "%i", ++iIP[2]);
						else if (Screen->GetSelTextIndex() == MENU_IP_3)
							Screen->modifica_comando(MENU_IP_3, true, "%i", ++iIP[3]);						
					}
					else if (com2=='a')
					{
						if (Screen->GetSelTextIndex() == MENU_IP_0)
							Screen->modifica_comando(MENU_IP_0, true, "%i", --iIP[0]);
						else if (Screen->GetSelTextIndex() == MENU_IP_1)
							Screen->modifica_comando(MENU_IP_1, true, "%i", --iIP[1]);
						else if (Screen->GetSelTextIndex() == MENU_IP_2)
							Screen->modifica_comando(MENU_IP_2, true, "%i", --iIP[2]);
						else if (Screen->GetSelTextIndex() == MENU_IP_3)
							Screen->modifica_comando(MENU_IP_3, true, "%i", --iIP[3]);						
					}
					else if (com2==' ')
					{
						if (Screen->GetSelTextIndex() == MENU_OK)
						{
							//audioSystem[2]->Play(sndSelezione, 1);
							cli = cSock.InitClientSocket(iIP, NETWORK_PORT, "Socket Client");							
							sockChatRiceve = cSock.InitClientSocket(iIP, NETWORK_PORT_CHAT_INVIA, "Socket chat ricezione");
							sockChatInvia  = cSock.InitClientSocket(iIP, NETWORK_PORT_CHAT_RICEVE, "Socket chat invio");
							
							done=4;      // ******************
						}
						if (Screen->GetSelTextIndex() == MENU_INDIETRO)
						{
							Menu2PNET(Screen);
								
							com='m';
						}
					}

					if ((keys[VK_SPACE]==FALSE)||((com2!='a')&&(com2!='d'))) com2='<';  // se premo spazio (per modificare l'ip) il numero scorre velocemente
					Screen->Disegna(&com2);
				}
				else if (com=='2')   // men 2P NETWORK SERVER IN ATTESA
				{
					if ((keys[VK_ESCAPE]==TRUE)||(in_connessione))
					{
						cSock.ThreadManager.closeThrd(1);             // ************************** non chiudono il thread.. il socket resta in ascolto - BUG
						cSock.ThreadManager.freeThrds();
						
						if (keys[VK_ESCAPE]==TRUE)  // connessione annullata
						{
							Menu2PNET(Screen);
							Screen->testoActive=true;
							
							com='m';
						}
						else                        // se la connessione  stata effettuata (serv  il Socket connesso)
						{
						//	serv = *sclient;
							done=3;  //**********************************
						}						
					}

					Screen->Disegna(&com2);
				}
				else if (com=='r') // riconoscimenti
				{
					Screen->Disegna(&com2);

					if (com2==' ')
					{						
						Screen->riconoscimenti=false;
						done=19;
					}					
				}
				else if (com=='m') // sotto-men
				{	
					if (com2=='w')
					{
						audioSystem[1]->Play(sndCambia, 0);
						Screen->SelTextNext();
					}
					else if (com2=='s')
					{
						audioSystem[1]->Play(sndCambia, 0);
						Screen->SelTextPrec();
					}
					else if (com2==' ')
					{
						if (Screen->GetSelTextIndex() == MENU_INDIETRO)
						{
							Screen->testoActive=false;						
							com='<';
						}
						else if (Screen->GetSelTextIndex() == MENU_INDIETRO_OPT)
						{
							Screen->mostraAvversario=false;
							Screen->mostraImgStage=false;
							MenuOpzioni(Screen);
						}
						else if (Screen->GetSelTextIndex() == MENU_SERVER)
						{
					//		audioSystem2->Play(suonoScelta, 1);
							Screen->scrivi(0, MENU_NULL, false, "Sono in attesa di un client - premi esc per annullare"); 
							serv = cSock.OpenServer(NETWORK_PORT);
							sockChatInvia  = cSock.OpenServer(NETWORK_PORT_CHAT_INVIA);
							sockChatRiceve = cSock.OpenServer(NETWORK_PORT_CHAT_RICEVE);
							
							serv = cSock.AspettaUnClient(&serv, 1);	
							sockChatInvia = cSock.AspettaUnClient(&sockChatInvia, 2);	
							sockChatRiceve = cSock.AspettaUnClient(&sockChatRiceve, 3);	

							com='2';
							
						}
						else if (Screen->GetSelTextIndex() == MENU_CLIENT)
						{
					//		audioSystem2->Play(suonoScelta, 1);
							com='c';    // al prossimo ciclo si torner a questa riga di codice
							
							MenuClient(Screen);
						}
						else if (Screen->GetSelTextIndex() == MENU_STAGE)
						{
					//		audioSystem2->Play(suonoScelta, 1);
							
							MenuStage(Screen);

							Screen->SetImmagineScenario(Stage);
							Screen->mostraImgStage=true;							
						}
						else if (Screen->GetSelTextIndex() == MENU_STAGE1)
						{
					//		audioSystem2->Play(suonoScelta, 1);
							
							Stage = STAGE_TAVOLINO;	
							Screen->SetImmagineScenario(Stage);
						}
						else if (Screen->GetSelTextIndex() == MENU_STAGE2)
						{
					//		audioSystem2->Play(suonoScelta, 1);
							
							Stage = STAGE_DESERTO;
							Screen->SetImmagineScenario(Stage);

						//	MenuOpzioni(Screen);
							//com='m';
						}						
						else if (Screen->GetSelTextIndex() == MENU_AVVERSARIO)
						{							
							MenuAvversari(Screen);
						}
						else if (Screen->GetSelTextIndex() == MENU_AVVERSARIO1)
						{							
							Screen->SetImmagineAvversario(AVVERSARIO1);
							Avversario=1;
							Avversario_livello=AVVERSARIO_LIVELLO1;
							
							Screen->mostraAvversario=true;
						}
						else if (Screen->GetSelTextIndex() == MENU_AVVERSARIO2)
						{							
							Screen->SetImmagineAvversario(AVVERSARIO2);
							Avversario=2;
							Avversario_livello=AVVERSARIO_LIVELLO2;
							
							Screen->mostraAvversario=true;
						}

						else if (Screen->GetSelTextIndex() == MENU_LUCI)
						{							
							if (illuminato==0)
							{
								illuminato=1;							
							}
							else
							if (illuminato==1)
							{
								illuminato=2;							
							}
							else
							if (illuminato==2)
							{
								illuminato=0;							
							}
							Screen->modifica_comando(MENU_LUCI, true, "Illuminazione: %i", illuminato);
						}

						else if (Screen->GetSelTextIndex() == MENU_RISOLUZIONE)
						{			
							Screen->KillGLWindow();
							if (SCREEN_X==640)
							{
								SCREEN_X=800;
								SCREEN_Y=600;								
							}
							else if (SCREEN_X==800)
							{
								SCREEN_X=1024;
								SCREEN_Y=768;
							}
							else if (SCREEN_X==1024)
							{
								SCREEN_X=640;
								SCREEN_Y=480;
							}
							//Screen->modifica_comando(MENU_RISOLUZIONE, true, "Risoluzione dello schermo: %i * %i", SCREEN_X, SCREEN_Y);
							//Screen->ReSizeGLScene(SCREEN_X, SCREEN_Y);
							Screen->Screen_X=SCREEN_X;
							Screen->Screen_Y=SCREEN_Y;

							Screen->CreateGLWindow(Screen->Wnd_Name,SCREEN_X,SCREEN_Y,SCREEN_BITS,Screen->fullscreen);

							done=-10;
						}

						else if (Screen->GetSelTextIndex() == MENU_BIT_RATE) // sar necessario riavviare il gioco --> file di configurazione
						{
							Screen->KillGLWindow();						// Distrugge la finestra corrente

							if (SCREEN_BITS==16)
							{
								SCREEN_BITS=24;						
							}
							else if (SCREEN_BITS==24)
							{
								SCREEN_BITS=32;
							}
							else if (SCREEN_BITS==32)
							{
								SCREEN_BITS=8;
							}
							else if (SCREEN_BITS==8)
							{
								SCREEN_BITS=16;
							}
							Screen->Screen_BITS=SCREEN_BITS;

							Screen->CreateGLWindow(Screen->Wnd_Name,SCREEN_X,SCREEN_Y,SCREEN_BITS,Screen->fullscreen);
					
							done=-10;		
						}

						else if (Screen->GetSelTextIndex() == MENU_FULL_SCREEN)
						{							
							Screen->KillGLWindow();						// Distrugge la finestra corrente
							Screen->fullscreen=!Screen->fullscreen;				// Cambia tra modalit Schermo intero/Finestra
							Screen->CreateGLWindow(Screen->Wnd_Name,SCREEN_X,SCREEN_Y,SCREEN_BITS,Screen->fullscreen);
					
							done=-10;
						}							

					/*	else if (Screen->GetSelTextIndex() == MENU_MUSICHE)
						{							
							Screen->SetImmagineAvversario(AVVERSARIO2);
							Avversario=2;
							Avversario_livello=AVVERSARIO_LIVELLO2;
							
							Screen->mostraAvversario=true;
						}

						else if (Screen->GetSelTextIndex() == MENU_EFFETTI_SONORI)
						{							
							Screen->SetImmagineAvversario(AVVERSARIO2);
							Avversario=2;
							Avversario_livello=AVVERSARIO_LIVELLO2;
							
							Screen->mostraAvversario=true;
						}
						*/


					}				

					com2='m';
					Screen->Disegna(&com2);
				}
				else Screen->Disegna(NULL);  // cubo in movimento
					

				/* se ho mosso, ruoto il cubo */
				    if (mosso==1)
					{
						if (tmp_rot<scelta_x){							
							tmp_rot+=0.05f;
							Screen->RotateObjectID(SCELTA1, 90.0f*(tmp_rot), 'x');
							Screen->RotateObjectID(SCELTA2, -90.0f*(tmp_rot), 'x');
						}else
						{
							com='<';
							audioSystem[1]->Play(sndCambia, 0);
						}
						
					}
					else if (mosso==-1)
					{
						if (tmp_rot>scelta_x){							
							tmp_rot-=0.05f;
							Screen->RotateObjectID(SCELTA1, 90.0f*(tmp_rot), 'x');
							Screen->RotateObjectID(SCELTA2, -90.0f*(tmp_rot), 'x');
						}else
						{
							audioSystem[1]->Play(sndCambia, 0);
							com='<';
						}
					}
					else if (mosso==2)
					{
						if (tmp_rot<scelta_y){						
							tmp_rot+=0.05f;
							Screen->RotateObjectID(SCELTA1, 90.0f*(tmp_rot-1), 'y');
							Screen->RotateObjectID(SCELTA2, -90.0f*(tmp_rot-1), 'y');
						}else
						{
							audioSystem[1]->Play(sndCambia, 0);
							com='<';
						}
					}
					else if (mosso==-2)
					{
						if (tmp_rot>scelta_y){							
							tmp_rot-=0.05f;
							Screen->RotateObjectID(SCELTA1, 90.0f*(tmp_rot-1), 'y');
							Screen->RotateObjectID(SCELTA2, -90.0f*(tmp_rot-1), 'y');
						}else
						{
							audioSystem[1]->Play(sndCambia, 0);
							com='<';
						}
					}					
			}			
			
			for (i=0; i<msSleep; i++) 
				ttempo=strcmp("sss","ssssssss");
		}

	audioSystem[1]->Stop(sndCambia);
	delete sndCambia;
	audioSystem[2]->Stop(sndSelezione);
	delete sndSelezione;

	Screen->DelFromWorld(SCELTA2);
	Screen->DelFromWorld(SCELTA1);
	Screen->DestroyWorld();
	
	return done;
}

// riguardo mondo ci sar una lista di mondi con i file nff relativi
// sar uguale per avversario, ma con la differenza di 2 numeri riservati che
//  indicheranno l'avversario utente sullo stesso PC o sul network
/*
     *** AVVERSARI ***
	 -1 = 2P
	 -2 = 2P NET (sono il SERVER)
	 -3 = 2P NET (sono il CLIENT)
	  1 = COMPUTER
*/
int Livello(GLWVideo *Screen, short int Avversario, bool colBianco, CAudioSystem **audioSystem) // mi s che Mondo  inutile
{
	Screen->InitWorldVar();	

	/* sistema audio */
		CAudio *sndCambia, *sndMuovi, *sndEsplosione;
		
		sndCambia = audioSystem[0]->Create("data/suoni/MuoviSelezione.wav", false);
		sndMuovi = audioSystem[1]->Create("data/suoni/MuoviPezzo.wav", false);
		sndEsplosione = audioSystem[2]->Create("data/suoni/Esplosione.wav", false);
			
	
		audioSystem[2]->Play(sndEsplosione, 0);
	/* inizializzo il mondo */	
		Screen->InitOrDestroy(Stage, illuminato, TRUE);

	/* Variabili del ciclo di gioco */			
		MSG		msg;									// Struttura Windows Message 
		BOOL	done=FALSE;								// Variabile Bool per uscire dal ciclo
	
	/* Start colonna sonora */
		//ThrdMan.initThrd(TD_SUONI1, &PlaySound/*sndPlaySound*/, (LPVOID)("Data/Sounds/Sottofondo.wav", SND_NOSTOP|SND_LOOP|SND_ASYNC|SND_FILENAME, NULL));
		 //sndPlaySound("Data/Sounds/Intro_OliSoft.wma", SND_NOSTOP|SND_LOOP|SND_ASYNC|SND_FILENAME);

	/* fps */
		char com, com2;   // necessario per avere il men di gioco
		int i, nmossa=1;
		long tempo=timeGetTime(), ttempo; // restituisce il time di sistema (windows) in millisecondi		
		long attesa;		
		int msSleep=90000; // attesa ad ogni ciclo		
		int modifica=0;    // variabile per attutire gli sbalzi di velocit
		int count_fps=0;
		GLfloat deg;				// Facing Degree

		bool modeCur=false;         // se true siamo in modalit "spostamento visuale"

	/* variabili per la comunicazione di rete */
		char buffer[256], chatBuffer[256], *buf;     // stringhe da inviare o ricevere al socket
		buffer[0]='\0';
		chatBuffer[0]='\0';
		buf=NULL;
		
		BUF_SOCKET *bsMossa, *bsChat;
		
		bsMossa = new BUF_SOCKET;
		bsMossa->buffer=buffer;
		if (Avversario==-2)		     // 2PNET_io sono il server							
			bsMossa->s=&serv;		
		else if (Avversario==-3)	 // 2PNET_io sono il client		
			bsMossa->s=&cli;

		bsChat = new BUF_SOCKET;
		bsChat->buffer=chatBuffer;
		bsChat->s=&sockChatRiceve;


		ShowCursor(TRUE);

	char  strmossa[20]    = {0};
	int   daX, daY;

	/* Funzioni di rand unite in un'unica classe */
		RandScacchi CRS;
		
	/* stato iniziale di gioco */
		if (colBianco) STATE = SWAIT_ME;           // muovo io per primo?
		else
		{
			STATE = SMOVE;     // o l'avversario
			CRS.cambiacolore();
			CRS.calcolamosse(0);
		}

	/* avversario */
		Screen->mostraAvversario=true;
		if (Avversario>0)
		{			
			CRS.livello=Avversario_livello;
		}
		else
		{
			Screen->SetImmagineAvversario(NULL);
		}
			
		bool mangio=false;
	/* Imposto il punto di vista iniziale */
		keys[VK_F1]=true; // visuale da giocatore 1
		
	/* Se si tratta di una partita in rete, allora mi metto subito in ascolto della socket
	   per la chat */
		cSock.RiceviDa(bsChat, THREAD_RICEZIONE_CHAT);
		cSock.RiceviDa(bsMossa, THREAD_RICEZIONE_MOSSA);   // crea un nuovo thread in attesa sul socket									
		
	/* Ciclo di gioco */
		while(!done)									// Ciclo che si ripete finch done=FALSE
		{	
			if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// C' un messaggio in attesa?
			{
				if (msg.message==WM_QUIT)				// Abbiamo ricevuto un messaggio di chiusura?
				{
					done=TRUE;							// Se s, done=TRUE
				}
				else									// Se no, gestisci i messaggi Window 
				{
					TranslateMessage(&msg);				// Traduce il Messaggio
					DispatchMessage(&msg);				// Invia il Messaggio
				}
			}
			else										// Se non ci sono messaggi
			{	
				if ((Screen->sto_mangiando)&&(!mangio))
					audioSystem[2]->Play(sndEsplosione, 0);
				mangio=Screen->sto_mangiando;

				if ((Avversario<=-2)&&(keys['C'])&&(!Screen->scriviChat))
				{
					Screen->scriviChat=true;
					Screen->tasto_premuto='C';
				}
				
				if ((keys['V'])&&(!modeCur)&&(!Screen->scriviChat))
				{
					modeCur=true;
					ShowCursor(FALSE);
				}

				if (((keys[VK_ESCAPE] && !Screen->fESCAPE))/*||(keys[VK_LMENU])*/) // men
				{
					//ShowCursor(TRUE);
					
					if (((Screen->testoActive==false)||(keys[VK_TAB])) && (!Screen->scriviChat) && (!modeCur))
					{
						MenuGiocoPrincipale(Screen, Avversario);
						Screen->mostraAvversario=false;
						Screen->testoActive=true;
					
						com='m';
					}
					else  // doppio esc == MENU_INDIETRO
					{
						//ShowCursor(FALSE);
						Screen->mostraAvversario=true;
						Screen->testoActive=false;						
						com='<';
					}

					if (Screen->scriviChat)
					{
						Screen->scriviChat=false;
					}
					
					if (modeCur)
					{
						modeCur=false;
						ShowCursor(TRUE);
					}									
					

					Screen->fESCAPE=TRUE;
				}
				if (!keys[VK_ESCAPE])
					Screen->fESCAPE=FALSE;

				if (com=='m') // sotto-men
				{				
					if (com2=='w')
					{
						audioSystem[0]->Play(sndCambia, 0);
						Screen->SelTextNext();
					}
					else if (com2=='s')
					{
						audioSystem[0]->Play(sndCambia, 0);
						Screen->SelTextPrec();
					}
					else if (com2==' ') 
					{						
						if (Screen->GetSelTextIndex() == MENU_INDIETRO)
						{		
							audioSystem[0]->Play(sndCambia, 0);
							Screen->mostraAvversario=true;
							Screen->testoActive=false;						
							com='<';
						}
						else if (Screen->GetSelTextIndex() == MENU_VAI_MENU)
						{
							audioSystem[0]->Play(sndCambia, 0);
							done=-2;
							Screen->testoActive=false;						
							com='<';
						}
						else if (Screen->GetSelTextIndex() == MENU_ESCI)
						{
							audioSystem[0]->Play(sndCambia, 0);
							done=-1;
							Screen->testoActive=false;						
							com='<';
						}
						else if (Screen->GetSelTextIndex() == MENU_CHAT)
						{	
							audioSystem[0]->Play(sndCambia, 0);
							Screen->scriviChat=true;
							Screen->fW=TRUE;							
							com='<';
						}
						else if (Screen->GetSelTextIndex() == MENU_MODE_VISUALE)
						{	
							audioSystem[0]->Play(sndCambia, 0);
							Screen->testoActive=false;
							modeCur=true;
							ShowCursor(FALSE);
							com='<';
						}						
					}

					com2='m';
					Screen->Disegna(&com2);
				}				
				else
				{
					/*Gestione fps */			
						count_fps++;
						fps=GetFPS();					// Frames Per Second
						deg+=0.2f/(fps/60.0f);			// Spin The Sky
						if (count_fps>(fps/480))
						{	
							if (modeCur)
							{
								Mouse_move();
								Screen->controllaOrientamento();
							}
													
							count_fps=0;					
						}
						
						FPS();

					/* Gestione messaggi di chat */
						if (Screen->scriviChat)
						{
							if (com=='p') // devo inviare alla socket il messaggio
							{
								audioSystem[0]->Play(sndCambia, 0);
								cSock.SendTo(sockChatInvia, Screen->chatMioTesto);
								//cSock.SendTo(sockChatInvia, "\n");
								
								Screen->chatMioTesto[0]='\0';
								Screen->chatMioTestoLength=0;
								com='o';
								keys[VK_RETURN]=FALSE;
							}
						}
						
						if (chatBuffer[0]!='\0')        // ricevo un messaggio di chat
						{
							Screen->SetChatSuoTesto(chatBuffer);
							chatBuffer[0]='\0';

							cSock.RiceviDa(bsChat, THREAD_RICEZIONE_CHAT);  // crea un nuovo thread in attesa sul socket								
						}

					/* Gestione mosse - se la mossa  possibile coloro l'oggetto di azzurro, altrimenti di rosso */
						if (STATE == SWAIT_ME)
						{
							if (tmpMossa>=1000) // se  stata indicata una mossa		
							{
								Screen->gestioneMossaTmp(CRS.controlloMossa(tmpMossa));
								sprintf(strmossa, "Mossa = %d", tmpMossa);
							//	SetWindowText(hWnd, strmossa);
							}

							if (mossa>=1000)
							{	
								audioSystem[1]->Play(sndMuovi, 0);
								Screen->mostraAvversario=2;
								STATE = SMOVE;
								nmossa++;

								// invio la mossa all'avversario in rete, se necessario
								if (Avversario==-2)		     // 2PNET_io sono il server
								{
									buf = IntToStr(mossa);
									cSock.SendTo(serv, buf);
									cSock.SendTo(serv, "\n");

									buffer[0]='\0';

									cSock.RiceviDa(bsMossa, THREAD_RICEZIONE_MOSSA);  // crea un nuovo thread in attesa sul socket									
								}
								else if (Avversario==-3)	 // 2PNET_io sono il client
								{
									buf = IntToStr(mossa);
									cSock.SendTo(cli, buf);	
									cSock.SendTo(cli, "\n");

									buffer[0]='\0';

									cSock.RiceviDa(bsMossa, THREAD_RICEZIONE_MOSSA);   // crea un nuovo thread in attesa sul socket									
								}
							}
						}

						if (STATE == SMOVE)
						{							
							if ((nmossa==1)||(Screen->muovi_pezzo(mossa))) // ritorna 1 se la mossa  terminata
							{									
								if (nmossa!=1)
								{
									audioSystem[1]->Play(sndMuovi, 0);
										// s gi che  corretta --> la eseguo
										daX  = ((mossa%10000)-(mossa%1000))/1000;
										daY  = ((mossa%1000) -(mossa%100))/100;								
									CRS.modifica(mossa+(CRS.scac[daX][daY]*1000000));	
									vittoria=Screen->Muovi(mossa);
								}
							
								if (Avversario>0)
								{
									CRS.CompMossaScelta=false;
									Screen->mostraAvversario=3;
									STATE = SWAIT_COMPUTER_THINK;    // 1P
									nmossa++;
									ThreadManager.newThrd(1, &ComputerPensa, (void *)(&CRS)); // mossa computer									
								}
								else if (Avversario==-1)
								{
									STATE = SWAIT_ME;    // 2P							
									CRS.cambiacolore();							
									CRS.calcolamosse(0);
								}
								else if (Avversario<=-2)
								{
									STATE = SWAIT_NETWORK;  // l'avversario muove il pezzo  
									nmossa++;
									
								}								
							}
						}

						if (STATE == SWAIT_NETWORK)
						{
							if (buffer[0]!='\0')
							{								
								mossa = (int)strtod(buffer, NULL);

								audioSystem[1]->Play(sndMuovi, 0);
								// s gi che  corretta --> la eseguo
										daX  = ((mossa%10000)-(mossa%1000))/1000;
										daY  = ((mossa%1000) -(mossa%100))/100;								
									CRS.modifica(mossa+(CRS.scac[daX][daY]*1000000));										
 						
								CRS.calcolamosse(0);
								STATE = SWAIT_COMPUTER;								
							}
						}
						
						if (STATE == SWAIT_COMPUTER_THINK)
						{			
							if (CRS.CompMossaScelta)
							{		
								audioSystem[1]->Play(sndMuovi, 0);
								STATE = SWAIT_COMPUTER;
								mossa=CRS.mossa;
							}
						}	

						if (STATE == SWAIT_COMPUTER)
						{												
							if (Screen->muovi_pezzo(mossa)) // ritorna 1 se la mossa  terminata
							{
								audioSystem[1]->Play(sndMuovi, 0);
								Screen->mostraAvversario=1;
								vittoria=Screen->Muovi(mossa);								
								STATE = SWAIT_ME;						
							}
						}						
				
					/* Disegno */
						// Disegna la scena. Controlla il tasto ESC e i messaggi di chiusura dalla DrawGLScene()		
						if (Screen->scriviChat) 
							done = Screen->Disegna(&com);
						else 
							done = Screen->Disegna(NULL);
				}
		
			}			
			
			if (vittoria)  // gestione della vittoria
			{
				if (vittoria==1) MessageBox(NULL,"Vince il bianco", "V I T T O R I A ! ! !",MB_OK);
				else if (vittoria==2) MessageBox(NULL,"Vince il nero", "V I T T O R I A ! ! !",MB_OK);
				done=-10;
			}
			
			for (i=0; i<msSleep; i++) 
				ttempo=strcmp("sss","ssssssss");
		}

	audioSystem[0]->Stop(sndCambia);
	delete sndCambia;
	audioSystem[1]->Stop(sndMuovi);
	delete sndMuovi;
	audioSystem[2]->Stop(sndEsplosione);
	delete sndEsplosione;
		
	Screen->DestroyWorld();

	return done;
}



/* Funzioni di men */
	void MenuOpzioni(GLWVideo *Screen)
	{
		Screen->scrivi(0, MENU_INDIETRO,      false, "Indietro");		
		Screen->scrivi(1, MENU_STAGE,         false, "Scenario");
		Screen->scrivi(1, MENU_AVVERSARIO,    false, "Avversario");
		Screen->scrivi(1, MENU_LUCI,           true, "Illuminazione: %i", illuminato);
	//	Screen->scrivi(1, MENU_EFFETTI_SONORI, true, "Effetti sonori:", effetti_sonori);
	//	Screen->scrivi(1, MENU_MUSICHE,        true, "Musiche: %i", musiche);
		Screen->scrivi(1, MENU_BIT_RATE,       true, "Colori: %i bit", SCREEN_BITS);
		Screen->scrivi(1, MENU_RISOLUZIONE,    true, "Risoluzione dello schermo: %i * %i", SCREEN_X, SCREEN_Y);
		if (Screen->fullscreen) 
			Screen->scrivi(1, MENU_FULL_SCREEN, false, "Schermo intero: si");
		else
			Screen->scrivi(1, MENU_FULL_SCREEN, false, "Schermo intero: no");
		Screen->scrivi(1, MENU_NULL,          false, "__________________");
		Screen->scrivi(1, MENU_NULL,          false, "OPZIONI:");						
	}

	void MenuStage(GLWVideo *Screen)
	{
		Screen->scrivi(0, MENU_INDIETRO_OPT, false, "Indietro");						
		Screen->scrivi(1, MENU_STAGE2, false, MENU_STAGE_DESERTO);
		Screen->scrivi(1, MENU_STAGE1, false, MENU_STAGE_TAVOLINO);
		Screen->scrivi(1, MENU_NULL,  false, "__________________");							
		Screen->scrivi(1, MENU_NULL, false, "STAGE - SCENARI:");
	}

	void MenuAvversari(GLWVideo *Screen)
	{
		Screen->mostraAvversario=true;
		Screen->scrivi(0, MENU_INDIETRO_OPT, false, "Indietro");						
	//	Screen->scrivi(1, MENU_AVVERSARIO2, false, MENU_STAGE_DESERTO);
		Screen->scrivi(1, MENU_AVVERSARIO2, true, "%s, livello %i", AVVERSARIO2, AVVERSARIO_LIVELLO2);
		Screen->scrivi(1, MENU_AVVERSARIO1, true, "%s, livello %i", AVVERSARIO1, AVVERSARIO_LIVELLO1);
		Screen->scrivi(1, MENU_NULL,  false, "__________________");							
		Screen->scrivi(1, MENU_NULL, false, "AVVERSARI:");
	}

	void MenuClient(GLWVideo *Screen)
	{
		Screen->scrivi(0, MENU_INDIETRO, false, "Indietro");	
		Screen->scrivi(1, MENU_OK,   false, "OK");
		Screen->scrivi(1, MENU_IP_3, true, "%i", iIP[3]);
		Screen->scrivi(1, MENU_IP_2, true, "%i", iIP[2]);
		Screen->scrivi(1, MENU_IP_1, true, "%i", iIP[1]);
		Screen->scrivi(1, MENU_IP_0, true, "%i", iIP[0]);
		Screen->scrivi(1, MENU_NULL, false, "__________________");							
		Screen->scrivi(1, MENU_NULL, false, "INDIRIZZO IP:");
	}

	void MenuGiocoPrincipale(GLWVideo *Screen, short Avversario)
	{
		Screen->scrivi(0,     MENU_ESCI, false, "Esci dal gioco");  // automaticamente il comando selezionato diventa il primo // il secondo parametro  l'indice - cos da differenziare i comandi dei vari sotto-men
		Screen->scrivi(1, MENU_VAI_MENU, false, "Torna al menu'");  // 1 == aggiungi comando
		if (Avversario<=-2) // 2PNET
			Screen->scrivi(1, MENU_CHAT, false, "Modalita' chat ('C'). esc per uscire");  // passa alla modalit spostamento visuale
		Screen->scrivi(1, MENU_MODE_VISUALE, false, "Modalita' sposta visuale ('V'). esc per uscire");  // passa alla modalit spostamento visuale
		Screen->scrivi(1, MENU_INDIETRO, false, "Continua");        // 0 == resetta testo // si inseriscono al contrario!
	}		
	
	void Menu2PNET(GLWVideo *Screen)
	{
		Screen->scrivi(0, MENU_INDIETRO, false, "Indietro");  // 0 == resetta testo // si inseriscono al contrario!
		Screen->scrivi(1,   MENU_CLIENT, false, "Client");    // 1 == aggiungi comando
		Screen->scrivi(1,   MENU_SERVER, false, "Server");    // automaticamente il comando selezionato diventa il primo // il secondo parametro  l'indice - cos da differenziare i comandi dei vari sotto-men
	}
	
	void MenuRiconoscimenti(GLWVideo *Screen)
	{
		Screen->riconoscimenti=true;
		Screen->scrivi(0, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "il testo ufficiale della licenza  disponibile all'URL http://www.gnu.org/licenses/gpl.html");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Per ulteriori dettagli sulla licenza vedere l'intestazione del file Lesson10.cpp");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "GNU General Public License,  versione 3");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Copyright (C) 2007 Giovanni Di Liberto");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "GLScacchi, gioco di scacchi tridimensionale in OpenGL");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " Licenza:");		
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Musiche originali, effetti sonori in parte");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " poi nel formato nff");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " tridimensionale freeware 3D Canvas, versione 6.5.0.2, ed esportati");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " progettati, a partire da zero, con il programma per la modellazione");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Tutti i modelli 3D, quindi le pedine, gli stage e gli altri, sono stati");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "  el Signor C., per l'aiuto con il logo che non ho finito, causa..nervoso");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "  Nikipe - BETA tester, e sopportatore cronico delle mie assillanti nuove idee");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "  Karl, per avermi supportato con consigli e idee");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "  Macros, per aver realizzato la torre (utilizzando Blender al posto di 3D Canvas)");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "  Alan De Renzis (aka Jambo), BETA tester, consigliere e fonte ispiratrice per Re Denzis");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Un grazie particolare a:");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " Autore: Giovanni Di Liberto (aka Oligoatria)");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, " Titolo del gioco:  The Last Chess");
		Screen->scrivi(1, MENU_NULL, false, " ");
		Screen->scrivi(1, MENU_NULL, false, "Nome del progetto: GLScacchi");
	}
