// netProtocol.h: source file del protocollo per la comunicazione di rete tramite socket
// by Oligoatria
////////////////////////////////////////////////////////////////////////////////////////

#include <winsock2.h>
#include "ThreadManager.h"
#include "netProtocol.h"

//SOCKET *sInvio, *sRicevo;
//SOCKET *sclient;
cThreadManager *sThreadManager;
char *_buffer;
bool in_connessione;

/* Apre il server su una porta e ritorna un riferimento al socket */
SOCKET cNetProtocol::OpenServer(int iPort)
{
    WORD sockVersion;
    WSADATA wsaData;
    int rVal;

	/* Il controllo Winsocket in windows richiede l'inizializazione */
		sockVersion = MAKEWORD(2,0);
		WSAStartup(sockVersion, &wsaData);
	
    /* Crea un socket internet, tcp, che usi il protocollo tcp/ip */
		SOCKET s = socket(PF_INET, SOCK_STREAM, 0/*IPPROTO_TCP*/);
		//SOCKET s = WSASocket (AF_INET, SOCK_STREAM, 0, 0, 0, 0);

	/* Controllo che il socket sia stato creato con successo */
		if(s == INVALID_SOCKET){
			WSACleanup();
			return SERVER_SOCKET_ERROR;
		}

	/* Riempiamo la struttura */
		SOCKADDR_IN sin;
		sin.sin_family = PF_INET;
		sin.sin_port = htons(iPort);
		sin.sin_addr.s_addr = INADDR_ANY;

    /* Ok, proviamo a bindare il server */
		rVal = bind(s, (LPSOCKADDR)&sin, sizeof(sin));
		if(rVal == SOCKET_ERROR){
			WSACleanup();
			return SERVER_SOCKET_ERROR;
		}

    /* Mettiti in ascolto per al massimo 1 client */
		rVal = listen(s, 1);
		if(rVal == SOCKET_ERROR){
			WSACleanup();
			return SERVER_SOCKET_ERROR;
		}

	return s;
}

/* Ritorna un oggetto SOCKET alla prima connessione di un client */
SOCKET cNetProtocol::AspettaUnClient(SOCKET *s, int ID)
{	
	sThreadManager=&ThreadManager;
	ThreadManager.newThrd(ID, &(WaitForClientConnection), (void *)s);	

    return *s;
}

/* Ritorna un oggetto SOCKET alla prima connessione di un client */
void WaitForClientConnection(SOCKET *s)
{	
    *s = accept(*s, NULL, NULL);

    if(*s == INVALID_SOCKET){
        WSACleanup();
        MessageBox(NULL,"SERVER_SOCKET_ERROR", "Errore 1",MB_OK|MB_ICONQUESTION);
    }
	else
		in_connessione=true;
    
	sThreadManager->closeStopThisThrd(1);
}

void cNetProtocol::RiceviDa(BUF_SOCKET *bs, unsigned int ID)
{
//	pBuffer[0]='\0';
/*	BUF_SOCKET *bs;
	bs = new BUF_SOCKET;
	bs->buffer=pBuffer;
	bs->s=s;*/

	ThreadManager.newThrd(ID, &(RecvFrom), (void *)(bs));
}

/* Funzione per ricevere un messaggio dalla socket */
int RecvFrom(BUF_SOCKET *bs)
{	
	char *tmpBuffer = new char[BUFFER_LENGTH];
	int res;	

	/* Azzera il buffer */
		bs->buffer[0] = '\0';

	/* Riceve i dati fino a che non viene inviato il carattere '\n' */
	do{
		res=recv(*bs->s,tmpBuffer,sizeof(tmpBuffer),0);
		
		/* Se riceve un pacchetto non valido esce */
			if (tmpBuffer[0] == '\0')
				return SERVER_SOCKET_ERROR;

			if (res>=0)	*(tmpBuffer+res)='\0';
			  lstrcat(bs->buffer,tmpBuffer);
	}while(*(tmpBuffer+res-1) != '\n');
	
	return SERVER_SOCKET_OK;
}

/* Funzione per inviare un messaggio alla socket */
int cNetProtocol::SendTo(SOCKET s, char *pText)
{
	//int i=lstrlen(pText);
	return send(s, pText,lstrlen(pText),0);
}


/* Funzione per inizializzare una socket client */
SOCKET cNetProtocol::InitClientSocket(unsigned int *iIndirizzo, int iPort, const char *nome_socket)
{
	int err = 0;
    
	SOCKET sock; // creo la socket chiamato sock che user nella connessione
	struct sockaddr_in sock_addr; // inizializzo la socket
	WSADATA data;  // inizializzo la variabile che contiene le primitive di Winsock
	WORD p;
	p=MAKEWORD(2,0);  // creo la variabile p che contiene la versione della wsock32.dll

	int errori = 0;
	for (int x=0; x<=5;x++){

		err = WSAStartup(p,&data); // inizializzo la wsock32.dll verificandone la mancanza di errori

		sock=socket(PF_INET,SOCK_STREAM,0);  // creo la socket indicandone le caratteristiche
		sock_addr.sin_family=PF_INET; // indico il protocollo utilizzato (TCP/IP)
		sock_addr.sin_port=htons(iPort); //indico la porta a cui connettere la socket
		sock_addr.sin_addr.S_un.S_un_b.s_b1=iIndirizzo[0]; // indico l'indirizzo IP
		sock_addr.sin_addr.S_un.S_un_b.s_b2=iIndirizzo[1];
		sock_addr.sin_addr.S_un.S_un_b.s_b3=iIndirizzo[2];
		sock_addr.sin_addr.S_un.S_un_b.s_b4=iIndirizzo[3];

		if (connect(sock, (SOCKADDR *)(&sock_addr), sizeof(sockaddr)) != 0)
		{
			MessageBox(NULL,"Errore nella connessione", nome_socket,MB_OK);
		} 
		else
		{
			MessageBox(NULL,"Connessione stabilita", nome_socket,MB_OK);
			return sock;
		}
	}

 return sock;
}
