// Gioco degli scacchi (win32/linux)
// by Rand

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define a 1
#define b 2
#define c 3
#define d 4
#define e 5
#define f 6
#define g 7
#define h 8

#define bianco 0
#define nero 1

#define vuoto 0
#define bre 1
#define bdon 2
#define balf 3
#define bcav 4
#define btor 5
#define bped 6
#define nre 7
#define ndon 8
#define nalf 9
#define ncav 10
#define ntor 11
#define nped 12

#define cambiacolore if (col_prof==bianco) col_prof=nero; else col_prof=bianco;

void calcolamosse (short int modo); //se modo=1 trova tutte le mosse di una posizione lasciandole nell'array globale possibili. Se modo=0 comincia una ricorsione indiretta con sceglimossa per trovare la mossa migliore.
void sceglimossa (unsigned int m);  
short int mossaimposs (unsigned int m);  //accetta una mossa in ingresso da calcolamosse, torna 0 o 1 se la mossa  accettabile, 2 se non lo .
void raccogli(); //si occupa raccogliere le mosse prodotte da calcolamosse quando modo=1 riempendo l'array possibili.
void inizializza(); //prepara le variabili globali per l'inizio della ricorsione fra calcolamosse e sceglimossa
void stampam(unsigned int m); //accetta in ingresso una mossa e la stampa in formato: lettera,numero-lettera,numero.
void stampap(); //disegna la scacchiera globale scac e la relativa posizione dei pezzi sullo schermo.
unsigned int acquisisci(); //chiede all'utente di inserire una mossa in formato lettera,numero-lettera,numero e la traduce in formato unsigned int
short int controllo(unsigned int m);   //Questa funzione  usata da acquisisci. COntrollo torna 0 se la mossa dell'utente non  accettabile.
void modifica(unsigned int m); //accetta in ingresso una mossa ed esegue la mossa sulla scacchiera globale scac[][].
void apertura();  //inizializza l'array ap con le aperture (prime mosse di una partita di scacchi). 
void apri(short int colore_utente); //A seconda che il computer giochi col bianco o col nero, apri sceglie una delle aperture contenute nell'array ap e la esegue. (gestisce le prime 2 mosse dela partita)
void vincitore(); //capisce se la partita  terminata (re catturato) dichiara il vincitore all'utente e fa terminare il programma.
void posiniz();  //Dispone i pezzi in posizione iniziale sulla scacchiera.
 


unsigned int mossa_giocata=0,mossa_in_analisi=0;
short int scac[10][10]; //LA prime e ultime righe e colonne sono inutilizzate. C' un bordo di caselle in pi per evitare l'errore di segmentation fault in certi punti del programma.
short int col_prof=bianco; //colore profondit.
short int nmossa=0; //numero di mossa: viene incrementato ad ogni mossa compita dall'tente o dal computer.
float effe=0; //effetto:  una variabile usata in fase di analisi della posizione.rappresenta l'effetto di una certa mossa (cattura di un pezzo, promozione di un pedone ecc.)
short int prof=0; //profondit.  la profondit di analisi della posizione.
short int livello=4; // la profondit masima di analisi
float ramo[7]; //array usato in fase di analisi. 
unsigned int possibili[100]; //array usato in fase di controllo di mossa dell'utente. Contiene tutte le mosse possibili di una posizione.
unsigned int ap[2][4][2]; //contiene le prime 2 mosse della partita gi preparate. 
int cont=0; // il contatore di possibili.



int main() {
    system("cls");
    printf("*****************************************\n");
    printf("*           Rand's Scacchi Game         *\n");
    printf("*     Version 1.0 (built under Linux)   *\n");
    printf("*****************************************\n");
    
	do {
		printf ("\nInserisci livello\n 1.facile (tempo di risposta immediato)\n 2.difficile (tempo di risposta medio 25 secondi)\n");
		printf("Scelta: ");
        scanf ("%d",&livello);
	}
	while (livello != 1 && livello !=2);
//	livello+=2;
	do {
		printf ("\nInserisci il colore con cui vuoi giocare\n 1.bianco\n 2.nero\n");
		printf("Scelta: ");
        scanf ("%d",&col_prof);
	}
	while (col_prof!=1 && col_prof !=2);
	
    system("cls");
	printf("*****************************************\n");
    printf("*           Rand's Scacchi Game         *\n");
    printf("*     Version 1.0 (built under Linux)   *\n");
    printf("*****************************************\n");
    
    if(livello==1)
      printf("\nMODALITA' GIOCO: FACILE\n");
    else
     printf("\nMODALITA' GIOCO: DIFFICILE\n");
    
    if(col_prof==1)
     printf(">>PEDINE BIANCHE\n\n");
    else
     printf(">>PEDINE NERE\n\n");
     
	
	col_prof--;
	posiniz();
	apertura();
	apri(col_prof);
	nmossa=4;
	if (col_prof==bianco)
		while (1) {
			modifica (acquisisci());
			vincitore();
			nmossa++;
			cambiacolore
			printf ("\nSto pensando\n");
			inizializza();
			calcolamosse(0);
			printf ("Io gioco:\n");
			stampam (mossa_giocata);
			modifica(mossa_giocata);
			nmossa++;
			cambiacolore
			stampap();
			vincitore();
		}
	else
		while(1) {
			cambiacolore
			printf ("\nSto pensando\n");
			inizializza();
			calcolamosse(0);
			printf ("Io gioco:\n");
			stampam (mossa_giocata);
			modifica (mossa_giocata);
			nmossa++;
			cambiacolore
			stampap();
			vincitore();
			modifica(acquisisci());
			vincitore();
			nmossa++;
		}
	return 0;
}


void apertura() {
	short int i;
	for (i=0;i<4;i++) {
		ap[bianco][i][0]=0;
		ap[bianco][i][1]=0;
		ap[bianco][i][0]=0;
		ap[bianco][i][1]=0;
	}
	ap[bianco][0][0]= (scac[e][2]*1000000) + (scac[e][4]*10000) + (e*1000) + (2*100) + (e*10) + 4;
	ap[bianco][0][1]= (scac[b][1]*1000000) + (scac[c][3]*10000) + (b*1000) + (1*100) + (c*10) + 3;
	ap[bianco][1][0]= (scac[d][2]*1000000) + (scac[d][4]*10000) + (d*1000) + (2*100) + (d*10) + 4;
	ap[bianco][1][1]= (scac[g][1]*1000000) + (scac[f][3]*10000) + (g*1000) + (1*100) + (f*10) + 3;
	ap[bianco][2][0]= (scac[g][1]*1000000) + (scac[f][3]*10000) + (g*1000) + (1*100) + (f*10) + 3;
	ap[bianco][2][1]= (scac[d][2]*1000000) + (scac[d][4]*10000) + (d*1000) + (2*100) + (d*10) + 4;
	ap[bianco][3][0]= (scac[g][2]*1000000) + (scac[g][3]*10000) + (g*1000) + (2*100) + (g*10) + 3;
	ap[bianco][3][1]= (scac[f][1]*1000000) + (scac[g][2]*10000) + (f*1000) + (1*100) + (g*10) + 2;
	ap[nero][0][0]=   (scac[d][7]*1000000) + (scac[d][5]*10000) + (d*1000) + (7*100) + (d*10) +5; 
	ap[nero][0][1]=   (scac[e][7]*1000000) + (scac[e][6]*10000) + (e*1000) + (7*100) + (e*10) +6;
	ap[nero][1][0]=   (scac[e][7]*1000000) + (scac[e][5]*10000) + (e*1000) + (7*100) + (e*10) +5;
	ap[nero][1][1]=   (scac[b][8]*1000000) + (scac[c][6]*10000) + (b*1000) + (8*100) + (c*10) +6;
	ap[nero][2][0]=   (scac[d][7]*1000000) + (scac[d][5]*10000) + (d*1000) + (7*100) + (d*10) +5;
	ap[nero][2][1]=   (scac[c][7]*1000000) + (scac[c][6]*10000) + (c*1000) + (7*100) + (c*10) +6;
	ap[nero][3][0]=   (scac[g][7]*1000000) + (scac[g][6]*10000) + (g*1000) + (7*100) + (g*10) +6;
	ap[nero][3][1]=   (scac[g][8]*1000000) + (scac[f][6]*10000) + (g*1000) + (8*100) + (f*10) +6;
}
			

void raccogli (unsigned int m) {
	possibili[cont]=m;
	cont++;
	possibili[cont]=0;
}


void vincitore() {
short int i,j,bian=0,ner=0;
	for (i=1;i<=8;i++)
		for (j=a;j<=h;j++)
			if (scac[i][j]==bre)
				bian=1;
			else if (scac[i][j]==nre)
				ner=1;
	if (ner==0) {
		printf ("\n\n\nIl bianco ha vinto!\n");
		exit(0);
	}
	if (bian==0) {
		printf ("\nIl nero ha vinto!\n");
		exit(0);
	}
}


void inizializza() {
mossa_giocata=0;
mossa_in_analisi=0;
effe=0;
prof=0;
int i;
	if (col_prof==bianco)
		for (i=0;i<6;i+=2) {
			ramo[i]=-100;
			ramo[i+1]=100;
	
		}
	else
		for (i=0;i<7;i+=2) {
			ramo[i]=100;
			ramo[i+1]=-100;
		}

}	


void sceglimossa (unsigned int m) {
	//modifica effetto globale con mossa m (si tiene conto di elementi posizionali)
	switch (scac[(m/10)%10][m%10]) {
		case nped: effe+=1; break;
		case ncav: effe+=3; break;
		case nalf: effe+=3; break;
		case ndon: effe+=10; break;
		case ntor: effe+=5; break;
		case nre:  effe+=41; break;
		case bped: effe-=1; break;
		case bcav: effe-=3; break;
		case balf: effe-=3; break;
		case bdon: effe-=10; break;
		case btor: effe-=5; break;
		case bre:  effe-=41; break;
	} 
	//modifica effetto in caso di sviluppo dei pezzi in apertura:
	if (nmossa<13 && prof==0) {
		if (col_prof==bianco) {
			if (  ( (m/10)%10 == c || (m/10)%10 == f || m%10==2 || m%10==3 )  && (m/1000000)%100 == bcav && (m/100)%10==1)
				effe+=0.8;
			if  ( (m/100)%10 == 1 && (m/1000000)%100 == balf)
				effe+=0.7;
			if ( ( (m/1000)%10==d || (m/1000)%10==e) && (m/1000000)%100 == bped && (m/100)%10==2) 
				effe+=0.9;
		} else {		
			if ( ( (m/10)%10 == c || (m/10)%10 == f || m%10==6 || m%10==7 ) && (m/1000000)%100==ncav && (m/100)%10==8)
				effe-=0.8;
			if (( m/100)%10 == 8 && (m/1000000)%100 == nalf)
				effe-=0.7;
			if ( ( (m/1000)%10==d || (m/1000)%10==e) && (m/1000000)%100 == nped && (m/100)%10==7)
				effe-=0.9;
		}
	}
	if (nmossa>53 && prof==0 &&((m/1000000)%100==bped || (m/1000000)%100 == nped)) {
		if (col_prof==bianco)
			effe+=0.9;
		else
			effe-=0.9;
	}
		
	//modifica scac con mossa m (con gestione caso di promozione pedone) 
	if ((m/1000000)%100==bped && (m%10)==8) //se scac[lp][np]==bped e na==8 
    {
		scac[(m/10)%10][m%10]=bdon;		      //scac[la][na] diventa bdon
		effe+=9;
	}
	else if ((m/1000000)%100==nped && (m%10)==1) //se scac[lp][np]==nped e na==1
	{
		scac[(m/10)%10][m%10]=ndon;			   //scac[la][na] diventa ndon
		effe-=9;
	}
	else
	{
		scac[(m/10)%10][m%10]=(m/1000000)%100;		   //altrimenti scac[la][na]=cp;
	}
	scac[(m/1000)%10][(m/100)%10]=vuoto;			   //scac[lp][np]=vuoto;
	//confronto mosse nel ramo, selezione mosse con ricorsione	
	if (prof==livello) {
		//confronto
		if ( (col_prof==bianco && effe > ramo[prof]) || (col_prof==nero && effe < ramo[prof])) 
			ramo[prof]=effe;
	} else {
		prof++;
		cambiacolore
		calcolamosse(0);
		prof--;
		cambiacolore
		/*if (prof==0) { stampam(mossa_in_analisi); printf (" %f\n",ramo[1]);}*/
		if  ( (col_prof==bianco && ramo[prof+1]>ramo[prof]) || (col_prof==nero && ramo[prof+1]<ramo[prof]) )
  		{
			if (prof==0)
				mossa_giocata=mossa_in_analisi; 
			ramo[prof]=ramo[prof+1];
		}
		if (col_prof==bianco)
			ramo[prof+1]=100;
		else
			ramo[prof+1]=-100;
	}
	//ripristino effetto apertura
	if (nmossa<13 && prof==0) {
		if (col_prof==bianco) {
			if (  ( (m/10)%10 == c || (m/10)%10 == f || m%10==2 || m%10==3 )  && (m/1000000)%100 == bcav && (m/100)%10==1)
				effe-=0.8;
			if  ( (m/100)%10 == 1 && (m/1000000)%100 == balf)
				effe-=0.7;
			if ( ( (m/1000)%10==d || (m/1000)%10==e) && (m/1000000)%100 == bped &&(m/100)%10==2) 
				effe-=0.9;
		} else {
			if ( ( (m/10)%10 == c || (m/10)%10 == f || m%10==7 || m%10==6 ) && (m/1000000)%100==ncav && (m/100)%10==8)
				effe+=0.8;
			if (( m/100)%10 == 8 && (m/1000000)%100 == nalf)
				effe+=0.7;
			if ( ( (m/1000)%10==d || (m/1000)%10==e) && (m/1000000)%100 == nped && (m/100)%10==7)
				effe+=0.9;
		}
	}		
	//ripristino vantaggio spinta pedoni nel finale
	if (nmossa>53 && prof==0 && ((m/1000000)%100==bped || (m/1000000)%100 == nped)) {
		if (col_prof==bianco)
			effe-=0.9;
		else
			effe+=0.9;
	}
	//ripristino scac, effe con mossa m
	scac[(m/1000)%10][(m/100)%10]=(m/1000000)%100; //scac[lp][np]=cp;
	scac[(m/10)%10][m%10]=(m/10000)%100;		//scac[la][na]=ca;
	switch (scac[(m/10)%10][m%10]) {
		case nped: effe-=1; break;
		case ncav: effe-=3; break;
		case nalf: effe-=3; break;
		case ndon: effe-=10; break;
		case ntor: effe-=5; break;
		case nre:  effe-=41; break;
		case bped: effe+=1; break;
		case bcav: effe+=3; break;
		case balf: effe+=3; break;
		case bdon: effe+=10; break;
		case btor: effe+=5; break;
		case bre:  effe+=41; break;
	}
	
	//gestione ripristino effetto in caso di promozione
	if ((m/1000000)%100==bped && (m%10)==8) //se scac[lp][np]==bped e na==8
		effe-=9;
	if ((m/1000000)%100==nped && (m%10)==1) //se scac[lp][np]==nped e na==1
		effe+=9;
}


void stampap() {
printf ("\n");
short int let,num;

	if (col_prof==bianco) {
	printf ("  ABCDEFGH\n\n");
	for (num=8;num>0;num--) {
		printf ("%d ",num);
		for (let=1;let<9;let++)
			switch (scac[let][num]) {
				case vuoto: printf ("."); break;
				case bre:   printf ("r"); break;
				case bdon:  printf ("d"); break;
				case balf:  printf ("a"); break;
				case bcav:  printf ("c"); break;
				case btor:  printf ("t"); break;
				case bped:  printf ("p"); break;
				case nre:   printf ("R");  break;
				case ndon:  printf ("D"); break;
				case nalf:  printf ("A"); break;
				case ncav:  printf ("C"); break;
				case nped:  printf ("P"); break;
				case ntor:  printf ("T"); break;
				default: printf ("X");
			}
		printf (" %d",num);
		printf ("\n");
    }
		printf ("\n  ABCDEFGH\n");
	} else {
		printf ("  HGFEDCBA\n\n");
	for (num=1;num<9;num++) {
		printf ("%d ",num);
		for (let=8;let>0;let--)
			switch (scac[let][num]) {
				case vuoto: printf ("."); break;
				case bre:   printf ("r"); break;
				case bdon:  printf ("d"); break;
				case balf:  printf ("a"); break;
				case bcav:  printf ("c"); break;
				case btor:  printf ("t"); break;
				case bped:  printf ("p"); break;
				case nre:   printf ("R"); break;
				case ndon:  printf ("D"); break;
				case nalf:  printf ("A"); break;
				case ncav:  printf ("C"); break;
				case nped:  printf ("P"); break;
				case ntor:  printf ("T"); break;
				default: printf ("X");
			}
		printf (" %d",num);
		printf ("\n");
	}
		printf ("\n  HGFEDCBA\n");
	}
}


void stampam(unsigned int m) {
	int lp,np,la,na;
	lp=(m/1000)%10;
	np=(m/100) %10;
	la= (m/10)%10;
	na=m%10;
	printf ("%c%d-%c%d\n",lp+'a'-1,np,la+'a'-1,na);
}


short int mossaimposs(unsigned int m) {
	//il pezzo non pu andare fuori dalla scacchiera
	if ( ((m/10)%10)>h || ((m/10)%10)<a )
		return 2;
	if ((m%10)>8 || (m%10)<1)
		return 2;
	//il pezzo non pu mangiare uno del suo colore
	if ( scac[(m/10)%10][m%10] <= 6 && scac[(m/10)%10][m%10] != vuoto && scac[(m/1000)%10][(m/100)%10] <= 6)
		return 2;
	if ( scac[(m/10)%10][m%10] >= 7 && scac[(m/1000)%10][(m/100)%10] >= 7)
		return 2;
	//Il cavallo pu eseguire una sola mossa nella direzione
	if ( scac[(m/1000)%10][(m/100)%10] == bcav || scac[(m/1000)%10][(m/100)%10] == ncav)
		return 1;
	//Nessun pezzo, trane il cavallo, pu saltare un altro pezzo
	if( scac[(m/10)%10][m%10] != vuoto)
		return 1;
	//Se il pezzo  il re pu spostarsi di una sola casella:
	if ( scac[(m/1000)%10][(m/100)%10] == bre || scac[(m/1000)%10][(m/100)%10] == nre )
		return 1;	
	return 0;
}


//modo 0 per giocare. Modo 1 per riempire l'array di mosse possibili.
void calcolamosse(short int modo) {

#define apriciclo la=lp; na=np; do { m=0; m=m+(lp*1000); m=m+(np*100); 
#define completamossa m=m+na; m=m+(la*10);
#define chiudiciclo rit=mossaimposs(m); if (rit!=2) {m=m+(scac[(m/10)%10][m%10] * 10000); m=m+(scac[(m/1000)%10][(m/100)%10] * 1000000); if (prof==0) mossa_in_analisi=m; if (modo==0) sceglimossa(m); else raccogli(m);} } while (rit==0);
#define apriseq la=lp; na=np; m=0; m=m+(lp*1000); m=m+(np*100);
#define chiudiseq if (mossaimposs(m)!=2) {m=m+(scac[(m/10)%10][m%10] * 10000); m=m+(scac[(m/1000)%10][(m/100)%10] * 1000000);if (prof==0) mossa_in_analisi=m; if (modo==0) sceglimossa(m); else raccogli(m);}
 
	unsigned int m=0;
	short int lp,np,la,na;
	short int rit;
	for (np=1;np<=8;np++)
		for (lp=a;lp<=h;lp++) {
			if ( (col_prof==bianco && (scac[lp][np] == bdon || scac[lp][np] == bre || scac[lp][np] == btor))  || (col_prof==nero && (scac[lp][np] == ndon || scac[lp][np] == nre || scac[lp][np] == ntor) ) ) {
				/*avanti*/ 
				apriciclo 
				++na;
				completamossa
 				chiudiciclo
 				/*indietro*/
 				apriciclo
 				--na; 
				completamossa
 				chiudiciclo
 				/*destra*/
 				apriciclo 
				++la; 
				completamossa 
				chiudiciclo 
				/*sisnistra*/
 				apriciclo 	
				--la; 
				completamossa 
				chiudiciclo 	
			}
			if ( (col_prof==bianco && (scac[lp][np] == bdon || scac[lp][np] == bre ||  scac[lp][np] == balf)) || (col_prof==nero && (scac[lp][np] == ndon || scac[lp][np] == nre ||  scac[lp][np] == nalf) ) ) {
				/*avanti destra*/
 				apriciclo 
				++na;
 				++la;
 				completamossa 
				chiudiciclo
 				/*avanti sinistra*/ 
				apriciclo
 				++na;
 				--la;
 				completamossa 
				chiudiciclo
 				/*indietro destra*/ 
				apriciclo 
				--na;
 				++la; 
				completamossa 
				chiudiciclo
 				/*indietro sinistra*/ 
				apriciclo 
				--na; 
				--la; 
				completamossa 
				chiudiciclo
			}
			if ( (col_prof==bianco && scac[lp][np] == bcav) || (col_prof==nero && scac[lp][np] == ncav) ) {
				
				apriseq 
				na+=2; 
				la++; 
				completamossa 
				chiudiseq 
				apriseq 
				na+=2; 
				la--;
 				completamossa
			 	chiudiseq
 				apriseq 
				na-=2;
 				la++;
 				completamossa
 				chiudiseq
 				apriseq
 				na-=2;
 				la--; 
				completamossa
 				chiudiseq 
				apriseq 
				la+=2; 
				na++;
 				completamossa
 				chiudiseq
 				apriseq
 				la+=2;
 				na--;
 				completamossa 
				chiudiseq 
				apriseq
 				la-=2;
 				na++; 
				completamossa
 				chiudiseq
 				apriseq
 				la-=2;
 				na--;
 				completamossa
 				chiudiseq
			}
			if (scac[lp][np] == bped && col_prof==bianco) {
				//sequenza pedone bianco
				if (scac[lp][np+1] == vuoto) {
					apriseq
					na++; 
					completamossa 
					chiudiseq
				} 
				if (np==2 && scac[lp][np+1]==vuoto && scac[lp][np+2] ==vuoto)  { 
					apriseq 
					na+=2; 
					completamossa 
					chiudiseq 
				} 
				if (scac[lp+1][np+1]!=vuoto) {
					apriseq 
					la++; 
					na++; 
					completamossa						
					chiudiseq
				} 
				if (scac[lp-1][np+1]!=vuoto)  {
					apriseq 
					na++; 
					la--; 
					completamossa 
					chiudiseq
				} 
			}
			if (scac[lp][np] == nped && col_prof==nero) {
				//sequenza pedone nero
				if (scac[lp][np-1]==vuoto) {
					apriseq 
					na--; 
					completamossa 
					chiudiseq 
				}
				if (np==7 && scac[lp][np-1]==vuoto && scac[lp][np-2]==vuoto)  { 
					apriseq 
					na-=2; 
					completamossa 
					chiudiseq 
				} 
				if (scac[lp+1][np-1]!=vuoto) {
					apriseq 
					la++; 
					na--; 
					completamossa
 					chiudiseq
 				} 
				if (scac[lp-1][np-1]!=vuoto) {
					apriseq 
					na--; 
					la--; 
					completamossa 
					chiudiseq
				} 
			}	

		}

#undef apriciclo
#undef chiudiciclo
#undef completamossa
#undef apriseq
#undef chiudiseq

}


void posiniz() {
int i,j;

	for (i=0;i<10;i++)
		for (j=0;j<10;j++)
			scac[i][j]=vuoto;

	scac[a][1]=btor; scac[b][1]=bcav; scac[c][1]=balf; scac[d][1]=bdon;
	scac[e][1]=bre; scac[f][1]=balf; scac[g][1]=bcav; scac[h][1]=btor;
	for (i=a;i<=h;i++)
		scac[i][2]=bped;

	scac[a][8]=ntor; scac[b][8]=ncav; scac[c][8]=nalf; scac[d][8]=ndon; scac[e][8]=nre;
	scac[f][8]=nalf; scac[g][8]=ncav; scac[h][8]=ntor;
	for (i=a;i<=h;i++)
		scac[i][7]=nped;
}


void modifica(unsigned int m) {
	scac[(m/10)%10][m%10]=(m/1000000)%100;
	scac[(m/1000)%10][(m/100)%10]=vuoto;
	if (scac[(m/10)%10][m%10]==bped && (m%10)==8)
		scac[(m/10)%10][m%10]=bdon;
	if (scac[(m/10)%10][m%10]==nped && (m%10)==1)
		scac[(m/10)%10][m%10]=ndon;
}


unsigned int  acquisisci() {
int m,lp,np,la,na;
char s[20];

	do {
		printf ("\nInserisci mossa (lettera,numero - lettera,numero)\n");
		scanf ("%s",s);
		m=0;
		lp=(int)(s[0]-'a'+1);
		np=(int)(s[1]-'0');
		la=(int)(s[2]-'a'+1);
		na=(int)(s[3]-'0');
		m=m+(lp*1000);
		m=m+(np*100);
		m=m+(la*10);
		m=m+na;
		m=m+(scac[lp][np]*1000000);
		m=m+(scac[la][na]*10000);
	}
	while (controllo(m)==0);
	return m;
}


void apri(short int colore_utente) {
short int i;
time_t t;
time (&t);
srand(t);
short int casuale=rand()%4;

	for (i=0;i<2;i++)
		if (colore_utente==bianco) {
			stampap();
			modifica(acquisisci());
			printf ("\nIo gioco:\n");
			stampam (ap[nero][casuale][i]);
			modifica (ap[nero][casuale][i]);
			if (i==1) stampap();
		} else {
			printf ("\nIo gioco:\n");
			stampam (ap[bianco][casuale][i]);
			modifica(ap[bianco][casuale][i]);
			stampap();
			modifica(acquisisci());
		}
}


short int controllo (unsigned int m) {
cont=0;
calcolamosse(1);
short int i=0,superato=0;
	
    while (possibili[i]!=0)
		if (m==possibili[i++]) {
			superato=1;
			break;
		}
	return superato;
}

	
//la seguente funzione non  usata nel programma principale.
/*void assumiposiz() {
short int i,j;
	
    for (i=0;i<10;i++)
		for (j=0;j<10;j++)
 	       scac[i][j]=vuoto;
char s[10];
s[0]='1';
short int let,num,pezzo;

	while (s[0]!='0') {
		printf ("\nInserisci lettera, numero e pezzo\n");
		scanf ("%s",s);
		if (s[0]!='0') {
			let=(short int)(s[0]-'a'+1);
			num=(short int)(s[1]-'0');
			pezzo=(short int)((s[2]-'0')*10);
			pezzo=pezzo+(short int)(s[3]-'0');
			scac[let][num]=pezzo;
		}
	}
}*/


